
package BuildingPackage;


import GamePackage.*;
import ResearchPackage.*;
import java.util.ArrayList;
import java.util.List;

public class Building extends GameObject{
  
//Buildings
    public static List<Building> list = new ArrayList<>();
    public static int maxNumber = 160;
    
    public static CrystalMine crystalMine = new CrystalMine();    
    public static DeutSynth deutSynth = new DeutSynth();    
    public static MassPortal massPortal = new MassPortal();    
    public static MetalMine metalMine = new MetalMine();    
    public static NaniteFactory naniteFactory = new NaniteFactory();
    public static ResearchFacility researchFacility = new ResearchFacility();
    public static RobotFactory robotFactory = new RobotFactory();    
    public static Shipyard shipyard = new Shipyard();    
    public static SolarPowerPlant solarPowerPlant = new SolarPowerPlant();  
    public static FusionPowerPlant fusionPowerPlant = new FusionPowerPlant();
    public static Terraformer terraformer = new Terraformer();    
    public static Machinery machinery = new Machinery(); 
    
        
    public static void add(){
        list.add(crystalMine);
        list.add(deutSynth);
        list.add(massPortal);
        list.add(metalMine);
        list.add(naniteFactory);
        list.add(researchFacility);
        list.add(robotFactory);
        list.add(shipyard);
        list.add(solarPowerPlant);
        list.add(fusionPowerPlant);
        list.add(terraformer);
        list.add(machinery);  
    }
    
    public static int getNumber(){
        int buildingNumber=0;
        for(int i=0; i < list.size(); i++){
            buildingNumber = buildingNumber + list.get(i).stage; 
        }
        return buildingNumber;
    }
    
    public static void setMaxNumber(GameObject obj){
        if (obj.equals(terraformer))
            maxNumber = 150 + 10 * (terraformer.stage+1);
    }
    
    public static void setEnergyProd(GameObject obj){
        if (obj.equals(solarPowerPlant) || obj.equals(fusionPowerPlant)){
            solarPowerPlant.productionRate = solarPowerPlant.productionFactor * solarPowerPlant.stage * Math.pow(1.1, solarPowerPlant.stage)* Math.pow(1.07, Research.energyTech.stage)/3600;
            fusionPowerPlant.productionRate = fusionPowerPlant.productionFactor * fusionPowerPlant.stage * Math.pow((1.05 + Research.energyTech.stage * 0.01), fusionPowerPlant.stage)/3600;
            fusionPowerPlant.deutConsumption = (10 * fusionPowerPlant.stage * Math.pow(1.1, fusionPowerPlant.stage))*Tools.timeFactor/3600;
            Ressources.energyProd = (solarPowerPlant.productionRate + fusionPowerPlant.productionRate)*3600;

            for(int i=0; i < list.size(); i++){
                Building currentObj = list.get(i);
                if ((currentObj.equals(metalMine)) || (currentObj.equals(crystalMine)) || (currentObj.equals(deutSynth))){
                    Tools.setCosts(currentObj);
                    Tools.setTime(currentObj);
                    setProductionRate(currentObj);
                    Output.report(currentObj);
                }
            }
        }
}

    public static void setEnergyConsumption(GameObject obj){
        obj.energyConsumption = obj.energyConsumptionFactor * obj.stage * Math.pow(1.1, obj.stage);
        Ressources.totalEnergyConsumption = metalMine.energyConsumption + crystalMine.energyConsumption + deutSynth.energyConsumption + terraformer.energyConsumption;
        Ressources.energy = Ressources.energyProd - Ressources.totalEnergyConsumption;
    }
    
    public static void setProductionRate(GameObject obj){
        if ((obj.equals(metalMine)) || (obj.equals(crystalMine)) || (obj.equals(deutSynth))) {
            if (Ressources.energyProd < Ressources.totalEnergyConsumption){
               Ressources.reduceFactor = (Math.round(Ressources.energyProd / Ressources.totalEnergyConsumption*100.0)/1.0);

                for(int i=0; i < list.size(); i++){
                    GameObject currentObj = list.get(i);
                    if ((currentObj.equals(metalMine)) || (currentObj.equals(crystalMine)) || (currentObj.equals(deutSynth))) {
                        double productionRate = currentObj.productionFactor * Tools.timeFactor * currentObj.stage * Math.pow(1.1, currentObj.stage) * Math.pow(1.1, machinery.stage)* Ressources.reduceFactor/100 /3600;                 

                        if (currentObj.equals(metalMine)){
                            currentObj.productionRate = productionRate;
                            Ressources.metalProd = currentObj.productionRate;
                            Output.report(currentObj);
                        }  
                        if (currentObj.equals(crystalMine)){
                            currentObj.productionRate = productionRate;
                            Ressources.crystalProd = currentObj.productionRate;
                            Output.report(currentObj);
                        }   
                        if (currentObj.equals(deutSynth)){
                            currentObj.productionRate = productionRate;
                            Ressources.deuteriumProd = currentObj.productionRate - fusionPowerPlant.deutConsumption;
                            Output.report(currentObj);
                        } 
                    }
                }
            } 
            else {
                Ressources.reduceFactor = 100;
                for(int i=0; i < list.size(); i++){
                    GameObject currentObj = list.get(i);
                    if ((currentObj.equals(metalMine)) || (currentObj.equals(crystalMine)) || (currentObj.equals(deutSynth))) {
                        currentObj.productionRate = currentObj.productionFactor * Tools.timeFactor * currentObj.stage * Math.pow(1.1, currentObj.stage)* Math.pow(1.1, machinery.stage)/3600;

                         if (currentObj.equals(metalMine)){
                             Ressources.metalProd = currentObj.productionRate;
                             Output.report(currentObj);
                         }
                         if (currentObj.equals(crystalMine)){
                             Ressources.crystalProd = currentObj.productionRate;
                             Output.report(currentObj);
                         }
                         if (currentObj.equals(deutSynth)){
                             Ressources.deuteriumProd = currentObj.productionRate - fusionPowerPlant.deutConsumption;
                             Output.report(currentObj);
                         }
                    }
                }
            }
        }
    }

    
    
    
   @Override 
    public String toString()
    {
        return ( 
                name + " ("+stage + ")"
                + "\n"  
                + "\n"  
                + "\n"       
                + "\n"  
                + "\n Metal cost: " + Tools.convertNumber(metalCost)
                + "\n Crystal cost: " + Tools.convertNumber(crystalCost)
                + "\n Deuterium cost: " + Tools.convertNumber(deuteriumCost)
                + "\n" 
                + "\n Time: " + Tools.convertTime(time) 
                
        );
    }
    
    
    
        
    public Building (){
        super();
    }
    

}
