
package BuildingPackage;

import GamePackage.GUI;
import GamePackage.Tools;

public class CrystalMine extends Building{
      
    public CrystalMine(){
        super();
 
        this.name = "Crystal mine";
        this.metalStartCost = 30;
        this.crystalStartCost = 15;
        this.deuteriumStartCost = 0;
        this.costFactor = 1.6;
        this.productionFactor = 20;
        this.energyConsumptionFactor = 10;
        
        this.button = GUI.crystalButton;
        this.textArea = GUI.crystalTextArea;
    }
    
    
   @Override 
    public String toString()
    {
        return ( 
                name + " ("+stage + ")"
                + "\n"  
                + "\n Crystal production: " +  Tools.convertNumber(3600*productionRate)  
                + "\n Energy demand: " +  Tools.convertNumber(energyConsumption)        
                + "\n"  
                + "\n Metal cost: " + Tools.convertNumber(metalCost)
                + "\n Crystal cost: " + Tools.convertNumber(crystalCost)
                + "\n Deuterium cost: " + Tools.convertNumber(deuteriumCost)
                + "\n" 
                + "\n Time: " + Tools.convertTime(time) 
                
        );
    }
    
    
    
    
}
