
package BuildingPackage;

import GamePackage.GUI;
import GamePackage.Tools;

public class DeutSynth extends Building{
    
    public DeutSynth(){
        super();
 
        this.name = "Deuterium synthesizer";
        this.metalStartCost = 150;
        this.crystalStartCost = 50;
        this.deuteriumStartCost = 0;
        this.costFactor = 1.5;
        this.productionFactor = 10;
        this.energyConsumptionFactor = 20;
        
        this.button = GUI.deutButton;
        this.textArea = GUI.deutTextArea;
    }
    
   @Override 
    public String toString()
    {
        return ( 
                name + " ("+stage + ")"
                + "\n"  
                + "\n Deuterium production: " +  Tools.convertNumber(3600*productionRate)  
                + "\n Energy demand: " +  Tools.convertNumber(energyConsumption)        
                + "\n"  
                + "\n Metal cost: " + Tools.convertNumber(metalCost)
                + "\n Crystal cost: " + Tools.convertNumber(crystalCost)
                + "\n Deuterium cost: " + Tools.convertNumber(deuteriumCost)
                + "\n" 
                + "\n Time: " + Tools.convertTime(time) 
                
        );
    }
    
    
}

