
package BuildingPackage;

import GamePackage.GUI;
import GamePackage.Tools;

public class MetalMine extends Building{

    public MetalMine(){
        super();
 
        this.name = "Metal mine";
        this.metalStartCost = 40;
        this.crystalStartCost = 10;
        this.deuteriumStartCost = 0;
        this.costFactor = 1.5;
        this.productionFactor = 30;
        this.energyConsumptionFactor = 10;
        
        this.button = GUI.metalButton;
        this.textArea = GUI.metalTextArea;
    }
    
    @Override 
    public String toString()
    {
        return ( 
                name + " ("+stage + ")"
                + "\n"  
                + "\n Metal production: " +  Tools.convertNumber(3600*productionRate)  
                + "\n Energy demand: " +  Tools.convertNumber(energyConsumption)        
                + "\n"  
                + "\n Metal cost: " + Tools.convertNumber(metalCost)
                + "\n Crystal cost: " + Tools.convertNumber(crystalCost)
                + "\n Deuterium cost: " + Tools.convertNumber(deuteriumCost)
                + "\n" 
                + "\n Time: " + Tools.convertTime(time) 
                
        );
    }
    
    
}
