
package BuildingPackage;

import GamePackage.GUI;
import GamePackage.Tools;

public class RobotFactory extends Building{

    public RobotFactory(){
        super();
 
        this.name = "Robot factory";
        this.metalStartCost = 400;
        this.crystalStartCost = 120;
        this.deuteriumStartCost = 200;
        this.costFactor = 2;
        this.productionFactor = 20;
        this.energyConsumptionFactor = 10;
        
        this.button = GUI.robotButton;
        this.textArea = GUI.robotTextArea;
    }
    
           @Override 
    public String toString()
    {
        return ( 
                name + " ("+stage + ")"
                + "\n"  
                + "\n Accelerates ship and" 
                + "\n building production time"       
                + "\n"  
                + "\n Metal cost: " + Tools.convertNumber(metalCost)
                + "\n Crystal cost: " + Tools.convertNumber(crystalCost)
                + "\n Deuterium cost: " + Tools.convertNumber(deuteriumCost)
                + "\n" 
                + "\n Time: " + Tools.convertTime(time) 
                
        );
    }
    
}
    
    
    