
package BuildingPackage;

import GamePackage.GUI;
import GamePackage.Tools;
import ResearchPackage.Research;

public class SolarPowerPlant extends Building{

    public SolarPowerPlant(){
        super();
 
        this.name = "Solar power plant";
        this.metalStartCost = 50;
        this.crystalStartCost = 20;
        this.deuteriumStartCost = 0;
        this.costFactor = 1.5;
        this.productionFactor = 20;
        
        this.button = GUI.solarButton;
        this.textArea = GUI.solarTextArea;
    }
    
    
   @Override 
    public String toString()
    {
        return ( 
                name + " ("+stage + ")"
                + "\n"  
                + "\n Energy production: " +  Tools.convertNumber(3600*productionRate)
                + "\n"       
                + "\n"  
                + "\n Metal cost: " + Tools.convertNumber(metalCost)
                + "\n Crystal cost: " + Tools.convertNumber(crystalCost)
                + "\n Deuterium cost: " + Tools.convertNumber(deuteriumCost)
                + "\n" 
                + "\n Time: " + Tools.convertTime(time) 
                
        );
    }
    
    
}
