
package FightPackage;

import GamePackage.*;
import ShipPackage.*;
import ResearchPackage.*;
import java.util.ArrayList;
import java.util.List;

public class Enemy {
    
    public static long totalLostShips = 0;
    public static List <Long> lostShips = new ArrayList<>();
        
    public int stage = 0;
    public static int maxStage = 51;
    
    public boolean spied = false;
    public boolean targeted = false;
    public boolean defeated = false;
    
    double lootFactor = 0;
    public double metal = 0;
    public double crystal = 0;
    public double deuterium = 0;
    
    public List <Ship> eShipList = new ArrayList<>();
    public List <Ship> eShipInFleetList = new ArrayList<>();
    
    SmallTransporter eSmallTransporter = new SmallTransporter();     
    LargeTransporter eLargeTransporter = new LargeTransporter();
    LightFighter eLightFighter = new LightFighter();    
    HeavyFighter eHeavyFighter = new HeavyFighter();
    Cruiser eCruiser = new Cruiser();   
    BattleShip eBattleShip = new BattleShip(); 
    Dreadnought eDreadnought = new Dreadnought();   
    SpyDrone eSpyDrone = new SpyDrone();
    Destroyer eDestroyer = new Destroyer();  
    
    public void addShips(){
        eShipList.add(eSmallTransporter);    
        eShipList.add(eLargeTransporter);
        eShipList.add(eLightFighter);
        eShipList.add(eHeavyFighter);
        eShipList.add(eCruiser);
        eShipList.add(eBattleShip);
        eShipList.add(eSpyDrone);    
        eShipList.add(eDestroyer);
        eShipList.add(eDreadnought);
        
        for (int i = 0; i < eShipList.size(); i++){
            eShipList.get(i).number = 0;
        }
    }     
     
    List<Research> eResearchList = new ArrayList<>();
    public SpyTech eSpyTech = new SpyTech();    
    public WeaponTech eWeaponTech = new WeaponTech();    
    public ArmorTech eArmorTech = new ArmorTech();    
    public ShieldTech eShieldTech = new ShieldTech(); 
    
    void addResearch(){
            eResearchList.add(eSpyTech);
            eResearchList.add(eWeaponTech);
            eResearchList.add(eArmorTech);
            eResearchList.add(eShieldTech);
        }  
    
    public Ship getShipByName(String name){
        Ship eShip = null;
            for(int i=0; i < eShipList.size(); i++){
            if (name.equals(eShipList.get(i).name))
                eShip = eShipList.get(i);
        }
        return eShip;
    }      
    
    public static List<Enemy> enemyList = new ArrayList<>();
    public static List<String> enemyReportList = new ArrayList<>();
    
    public static void newEnemy(Enemy newEnemy){
        enemyList.add(newEnemy);
        newEnemy.stage = enemyList.size();
        enemyReportList.add("Enemy Stage " + newEnemy.stage);
        newEnemy.setAllEnemyValues();
        GUI.enemyList.setListData(enemyReportList.toArray());
    }
    
    public static void renewEnemy(int stage){
        enemyList.get(stage-1).eShipList.clear();
        enemyList.get(stage-1).eResearchList.clear();
        enemyList.get(stage-1).setAllEnemyValues();
        enemyList.get(stage-1).spied = false;
        enemyReportList.set(stage-1,"Enemy Stage " + stage);
        GUI.enemyList.setListData(enemyReportList.toArray());
    }

    public static Enemy getLastEnemy(){
        Enemy lastEnemy = enemyList.get(enemyList.size()-1);
        return lastEnemy;
    }
    
    public static Enemy getRandomEnemy(int minStage, int maxStage){
        Enemy rndmEnemy = new Enemy();
        rndmEnemy.targeted = true;
        while (rndmEnemy.targeted ==true){
            int rndmEnemyStage = (int) (Math.random() * (maxStage - minStage) + minStage);
            rndmEnemy = Enemy.enemyList.get(rndmEnemyStage-1);
        }
        return rndmEnemy;
    }
    
    void setAllEnemyValues(){
        addShips();
        addResearch();
        setEnemyShipNumber();
        setEnemyResearchValues();
        setEnemyShipValues();
        setAvailableLoot();
    }
    
    void setEnemyShipNumber(){
        for (int i = 0; i< eShipList.size(); i++){
            Ship currentShip = eShipList.get(i);
            int shipNumber = (int) (Math.random() * (Math.ceil(currentShip.shipFactorA * stage * stage + currentShip.shipFactorB * stage + currentShip.shipFactorC)));
            if (shipNumber <= 0){
                currentShip.number = 0;
            } else {
                currentShip.number = shipNumber;
                eShipInFleetList.add(currentShip);
            }
        }    
    }

    public Ship improvedRandomShip(){
        double totalMass = 0;
        Ship rndmShip = null;
        for (int i = 0; i< eShipInFleetList.size(); i++){
            Ship currentShip = eShipInFleetList.get(i);
            totalMass = totalMass + currentShip.armor * currentShip.number;
        }
        int rndmNumber = (int) (Math.random() * 100);
        double low = 0;
        double high = 0;
        for (int i = 0; i< eShipInFleetList.size(); i++){
            Ship currentShip = eShipInFleetList.get(i);
            currentShip.impactFactor = (currentShip.armor * currentShip.number / totalMass)*100;
            high = high + currentShip.impactFactor;
            if ( low <= rndmNumber && rndmNumber <= high){
                rndmShip = currentShip;
                break;
            }
            low = low + currentShip.impactFactor;
        }
        return rndmShip;
    }

    
    public void setEnemyShipValues(){
        Ship currentShip;
        for(int i=0; i < eShipInFleetList.size(); i++){
            currentShip = eShipInFleetList.get(i);
            currentShip.attack =  (int) ((currentShip.groundAttack * (1+ eWeaponTech.stage / 10.0)));
            currentShip.armor =  (int) ((currentShip.metalCost + currentShip.crystalCost) / 10.0 * (1+ eArmorTech.stage / 10.0));
            currentShip.shield =  (int) (currentShip.groundShield * (1+ eShieldTech.stage / 10.0));
        }
    }
    
    void setEnemyResearchValues(){
            eSpyTech.stage =  (int) (Math.ceil(0.3 * stage));
            
            int eWeaponTechVar = (int) Math.ceil(-0.0032 * stage * stage + 0.5608 * stage - 0.0829);
            if (eWeaponTechVar < 0){
                eWeaponTech.stage = 0;
            } 
            else {
                eWeaponTech.stage =  eWeaponTechVar;
            }
            
            eArmorTech.stage =  (int) (Math.ceil(0.5 * stage));
            
            int eShieldTechVar = (int) Math.ceil(-0.0019 * stage * stage + 0.5365 * stage - 0.0497);
            if (eShieldTechVar < 0){
                eShieldTech.stage = 0;
            } 
            else {
                eShieldTech.stage =  eShieldTechVar;
            }
    }
    
    void setAvailableLoot(){
        lootFactor = 1+(maxStage-stage)/100.00;
        metal = (int) (6000 * Math.pow(lootFactor, stage));
        crystal = (int) (4000 * Math.pow(lootFactor, stage));
        deuterium = (int) (2000 * Math.pow(lootFactor, stage));
    }
    
    public void publish(){

        if (spied == true){
            GUI.enemyTextArea.setText("");
            int spyDifference = Research.spyTech.stage - eSpyTech.stage;

            if (spyDifference > -1){
                GUI.enemyTextArea.append("Metal: "+ Tools.convertNumber(metal) +"\n"
                                        +"Crystal: "+ Tools.convertNumber(crystal) +"\n"
                                        +"Deuterium: "+ Tools.convertNumber(deuterium) +"\n" +"\n");
            }

            if (spyDifference > 2){
                for (int i = 0; i< eShipInFleetList.size(); i++){
                    GUI.enemyTextArea.append(eShipInFleetList.get(i).name +": "+ Tools.convertNumber(eShipInFleetList.get(i).number) +"\n");
                }
            }

            if (spyDifference > 4){
                double wreckingloot = 0;
                for (int i = 0; i< eShipInFleetList.size(); i++){
                    wreckingloot = wreckingloot + eShipInFleetList.get(i).number * (eShipInFleetList.get(i).metalCost+eShipInFleetList.get(i).crystalCost+eShipInFleetList.get(i).deuteriumCost) * 0.3;    
                }
                GUI.enemyTextArea.append("\n" + "Wreckling loot: " +Tools.convertNumber(wreckingloot) +"\n"
                                        +"\n" +eSpyTech.name +": "+ eSpyTech.stage +"\n"
                                        +eWeaponTech.name +": "+ eWeaponTech.stage +"\n"
                                        +eArmorTech.name +": "+ eArmorTech.stage +"\n"
                                        +eShieldTech.name +": "+ eShieldTech.stage +"\n");
            }
        } else {
            GUI.enemyTextArea.setText("No Information available");
        }
    }
    
    public static Enemy nextEnemy(){
        Enemy nextEnemy = enemyList.get(GUI.enemyList.getSelectedIndex());
        return nextEnemy;
        
    }
    
    public void setTargeted(){
        targeted = true;
    }

  
    
    
}
