
package FightPackage;

import BuildingPackage.Building;
import GamePackage.*;
import ShipPackage.*;

import java.util.*;

public class Fleet{

    public String attackmode;
    
    public boolean returning = false;

    public static int static_ID = 0;
    public int ID = 0;
    
    public boolean resumed = false;
    
    public static List<String> currentFleetList = new ArrayList<>();   
    public static List<Fleet> fleetList = new ArrayList<>();
    
    public static List<String> fleetReportList = new ArrayList<>();
    
    public List<Ship> shipList = new ArrayList<>();
    public List<Integer> shipNumberList = new ArrayList<>();
     
    static List<GameObject> availableFleetList = new ArrayList<>();
    public static List<String> availableFleetReportList = new ArrayList<>();
    
    public static void setAvailableFleet(){
        availableFleetList.clear();
        availableFleetReportList.clear();
        for(int i = 0 ; i < Ship.list.size() ; i++){
            GameObject currentObj = Ship.list.get(i);
                if (currentObj.number > 0 ){
                    availableFleetList.add(currentObj);
                    availableFleetReportList.add(currentObj.name + " (" + Tools.convertNumber(currentObj.number) + ")");
                }
        }
    }
    
    public static void addShipToFleet(){
        int selectedIndex = GUI.availableFleetList.getSelectedIndex();
        int number = Integer.parseInt(GUI.selectedShipNumberTextField.getText());
        GameObject selectedShip = availableFleetList.get(selectedIndex);
        if (number > 0 && number <= selectedShip.number){
            currentFleetList.add(selectedShip.name + " " + Tools.convertNumber(number));
            selectedShip.number = selectedShip.number - number;
            availableFleetReportList.set(selectedIndex, selectedShip.name + " (" + Tools.convertNumber(selectedShip.number) + ")");
            setAvailableFleet();
            GUI.availableFleetList.setListData(availableFleetReportList.toArray());
            GUI.newFleetList.setListData(currentFleetList.toArray());
        }
        else if (number == 0 || number > selectedShip.number){
            currentFleetList.add(selectedShip.name + " " + selectedShip.number);
            selectedShip.number = 0;
            //availableFleetReportList.set(selectedIndex, selectedShip.name + " (" + Tools.convertNumber(selectedShip.number) + ")");
            setAvailableFleet();
            GUI.availableFleetList.setListData(availableFleetReportList.toArray());
            GUI.newFleetList.setListData(currentFleetList.toArray());
        }
        viewFleetInfo();
    }
    
    public static void removeShipFromFleet(){
        int selectedIndex = GUI.newFleetList.getSelectedIndex();
        int numberInFleet = 0;
        String currentIndex = currentFleetList.get(selectedIndex);
        for(int i=0; i < Ship.list.size(); i++){
            Scanner sc = new Scanner(currentIndex);
            GameObject currentObj = Ship.list.get(i);
            if (sc.next().equals(currentObj.name) == true){
                numberInFleet = Integer.parseInt(sc.next().replace(".", ""));
                if (currentFleetList.size()>0){
                    currentObj.number = currentObj.number + numberInFleet;
                    currentFleetList.remove(selectedIndex);
                    setAvailableFleet();
                    GUI.availableFleetList.setListData(availableFleetReportList.toArray());
                    GUI.newFleetList.setListData(currentFleetList.toArray());
                    break;
                }
            }
        }
        viewFleetInfo();
    }
    
    public static void removeAllShipsFromFleet(){
        while (currentFleetList.size()>0){
        int selectedIndex = 0;
        int numberInFleet = 0;
        String currentIndex = currentFleetList.get(selectedIndex);
            for(int j=0; j < Ship.list.size(); j++){
                Scanner sc = new Scanner(currentIndex);
                GameObject currentObj = Ship.list.get(j);
                if (sc.next().equals(currentObj.name) == true){
                    numberInFleet = Integer.parseInt(sc.next().replace(".", ""));
                    if (currentFleetList.size()>0){
                        currentObj.number = currentObj.number + numberInFleet;
                        currentFleetList.remove(selectedIndex);
                        setAvailableFleet();
                        GUI.availableFleetList.setListData(availableFleetReportList.toArray());
                        GUI.newFleetList.setListData(currentFleetList.toArray());
                    }
                }
            }
        }
    }
    
    public int indexInFleetList(){
        int index = 0;
        for (int i = 0; i < fleetList.size(); i++){
            Fleet currentFleet = fleetList.get(i);
            if (currentFleet.ID == this.ID){
                index = i;
                break;
            }
        }
        return index;
    }
    
    public void dockingFleet(){
        if (attackmode.equals("attacking")){
        for (int i = 0; i < shipList.size(); i++){
            GameObject currentShipInFleet = shipList.get(i);
            int number = shipNumberList.get(i);
            GameObject currentShip = Tools.getObjByName(currentShipInFleet.name);
            currentShip.number = currentShip.number + number;
            currentShip.textArea.setText(currentShip.toString());
        }
        
            GUI.historyTextArea.append("\n Fleet " + ID + " succesfully docked. \n");
            removeFleetFromList();
        }
        
    }
    
    public void removeFleetFromList(){
        emptySlot();
        fleetReportList.remove(indexInFleetList());
        fleetList.remove(indexInFleetList());
        GUI.fleetList.setListData(fleetReportList.toArray());
        setAvailableFleet();
        GUI.availableFleetList.setListData(availableFleetReportList.toArray());
        GUI.fleetTextArea.setText("");
    }
    
    public FleetSlot fleetSlot;
    
    void fillSlot(){
        fleetSlot = FleetSlot.freeSlot();
        fleetSlot.full = true;
    }
    
    public void emptySlot(){
        fleetSlot.full = false;
    }
    
    public static void newFleet(Fleet newFleet, Enemy enemy){
        if (FleetSlot.allFull() == false & FleetSlot.list.size() > 0){
            
            if (enemy.targeted == false){
                newFleet.attackmode="attacking";
                newFleet.setTarget(enemy);
                newFleet.setShipLists();
                if (newFleet.deutConsumption() < Ressources.deuterium){
                    Ressources.deuterium = Ressources.deuterium - newFleet.deutConsumption();
                    fleetList.add(newFleet);
                    newFleet.fillSlot();
                    newFleet.ID = ++static_ID;
                    newFleet.setFlightTime();
                    fleetReportList.add("Fleet " + newFleet.ID + ": "+ Tools.convertTime(newFleet.flightTime));
                    GUI.fleetList.setListData(fleetReportList.toArray());
                    currentFleetList.clear();
                    GUI.newFleetList.setListData(currentFleetList.toArray());
                    Countdown.flightTimer(newFleet);
                } else {
                    Enemy.nextEnemy().targeted = false;
                    newFleet.shipList.clear();
                    newFleet.shipNumberList.clear();
                    removeAllShipsFromFleet();
                }
            } else if(currentFleetList.isEmpty()){
                newFleet.setTarget(enemy);
                fleetList.add(newFleet);
                newFleet.fillSlot();
            }
        }
        else{
            removeAllShipsFromFleet();
        }
    }
    
   
    public static void viewFleetInfo(){
        int numberInFleet = 1;
        double totalCapacity = 0;
        double totalConsumption = 0;
        double velocity = 1000000000;
        int flightTime = 0;
        for(int i=0; i < Ship.list.size(); i++){
            Ship currentShip = Ship.list.get(i);
            for (int j= 0; j < currentFleetList.size(); j++){
                String currentIndex = currentFleetList.get(j);
                Scanner sc = new Scanner(currentIndex);
                if (sc.next().equals(currentShip.name) == true){
                    numberInFleet = Integer.parseInt(sc.next().replace(".", ""));
                    totalCapacity = totalCapacity + currentShip.cargoCapacity * numberInFleet;
                    
                    if (currentShip.velocity < velocity){
                    velocity = currentShip.velocity;
                    }
                    if (!GUI.enemyList.isSelectionEmpty()){
                        totalConsumption = totalConsumption + currentShip.deutConsumption * numberInFleet * Enemy.nextEnemy().stage / 350 * Math.pow( (Math.sqrt(velocity / currentShip.velocity)+1), 2) / Math.pow(1.25, Building.massPortal.stage);
                        flightTime = (int) (10 + (350.0 * Math.sqrt((1000000.0 + Enemy.nextEnemy().stage * 95000.0) / (velocity * Tools.timeFactor))));
                    }
                    
                    break;
                }
                else {
                    numberInFleet = 0;
                }
            }  
        }
        GUI.fleetCapacityLabel.setText(Tools.convertNumber(totalCapacity));
        GUI.fleetConsumptionLabel.setText(Tools.convertNumber(totalConsumption));
        GUI.fleetFlightTimeLabel.setText(Tools.convertTime(flightTime));
    }
    
    public void publish(){
        GUI.fleetTextArea.setText("");
        GUI.fleetTextArea.append( "Total flight time: " + Tools.convertTime(currentFlightTime) +"\n");
        if (returning == true){
            GUI.fleetTextArea.append("Returning to homebase" +"\n");   
            if (target.defeated == true){
                GUI.fleetTextArea.append("Deafeated Enemy Stage " + target.stage +"\n"
                                        +"Metal looted: " + Tools.convertNumber(loadedMetal) +"\n"
                                        +"Crystal looted: " + Tools.convertNumber(loadedCrystal) +"\n"
                                        +"Deuterium looted: " + Tools.convertNumber(loadedDeuterium) +"\n" +"\n");
            }
        } else {
            GUI.fleetTextArea.append("Target: Enemy Stage " + target.stage +"\n");    
        }
        for (int i = 0; i< shipList.size(); i++){
                GUI.fleetTextArea.append(shipList.get(i).name +": "+ Tools.convertNumber(shipNumberList.get(i)) +"\n");
        }
    }

    public void setShipLists(){ //in correct order
        int numberInFleet = 1;
        for(int i=0; i < Ship.list.size(); i++){
            Ship currentShip = Ship.list.get(i);
            if (attackmode.equals("attacking")){
                for (int j= 0; j < currentFleetList.size(); j++){
                    String currentIndex = currentFleetList.get(j);
                    Scanner sc = new Scanner(currentIndex);
                    if (sc.next().equals(currentShip.name) == true){
                        numberInFleet = Integer.parseInt(sc.next().replace(".", ""));
                        break;
                    }
                    else {
                        numberInFleet = 0;
                    }
                }
            }
            else if (attackmode.equals("defending")){
                numberInFleet = currentShip.number;
          //      currentShip.number = 0;
            }

            if (numberInFleet > 0){
                shipList.add(currentShip);
                shipNumberList.add(numberInFleet);
            }
        }
    }
    
    double fleetVelocity(){
        double velocity = 1000000000;
        for(int i=0; i < shipNumberList.size(); i++){ 
            if (shipList.get(i).velocity < velocity){
                velocity = shipList.get(i).velocity;
            }
        }    
        return velocity;
    }
    
    public int flightTime = 0;
    public int currentFlightTime = 0;
    
    void setFlightTime(){
        //flightTime = 2;
        flightTime = (int) (10 + (350.0 * Math.sqrt((1000000.0 + target.stage * 95000.0) / (fleetVelocity() * Tools.timeFactor))));
    }
    
    public Enemy target;
    
    void setTarget(Enemy enemy){
       this.target = enemy;
       enemy.setTargeted();
    } 

    public Ship improvedRandomShip(){
        double totalMass = 0;
        Ship rndmShip = null;
        for (int i = 0; i< shipList.size(); i++){
            Ship currentShip = shipList.get(i);
            totalMass = totalMass + currentShip.armor * shipNumberList.get(i);
        }
        int rndmNumber = (int) (Math.random() * 100);
        
        double low = 0;
        double high = 0;
        for (int i = 0; i< shipList.size(); i++){
            Ship currentShip = shipList.get(i);
            currentShip.impactFactor = (currentShip.armor * shipNumberList.get(i) / totalMass)*100;
            high = high + currentShip.impactFactor;
            if ( low <= rndmNumber && rndmNumber <= high){
                rndmShip = currentShip;
                break;
            }
            low = low + currentShip.impactFactor;
        }
        return rndmShip;
    }
    
    public int getShipIndex(Ship ship){
        int index = 0;
        for (int i = 0; i < shipList.size(); i++){
            if (ship.name.equals(shipList.get(i).name)){
                index = i; 
            }
        }
        return index;
    }

    double deutConsumption(){
        double deutConsumption = 0;
        for (int i = 0; i < shipList.size(); i++){
            GameObject currentShip = shipList.get(i);
            int number = shipNumberList.get(i);
            deutConsumption = deutConsumption + currentShip.deutConsumption * number * target.stage / 350 * Math.pow( (Math.sqrt(fleetVelocity() / currentShip.velocity)+1), 2) / Math.pow(1.25, Building.massPortal.stage);
        }
        return deutConsumption;
    }
    
    double fleetCapacity(){
        double fleetCapacity = 0;
        for (int i = 0; i < shipList.size(); i++){
            GameObject currentShip = shipList.get(i);
            int number = shipNumberList.get(i);
//            if (currentShip.equals(Ship.recycler))
//                    number = 0;
            fleetCapacity = fleetCapacity + currentShip.cargoCapacity * number;
        }
        fleetCapacity = fleetCapacity - deutConsumption();
        if (fleetCapacity < 0)
                fleetCapacity = 0;
        return fleetCapacity;
    }
    
    public double loadedMetal = 0;
    public double loadedCrystal = 0;
    public double loadedDeuterium = 0;
    
    public void loadLoot(){
        double rest = fleetCapacity();
        while ( (target.metal + target.crystal + target.deuterium) > 0 & rest > 0){
            
            if (target.metal > 0 & rest > 0){
                if (target.metal > 0.333*rest){
                    loadedMetal = loadedMetal + (int) (0.333 * rest);
                    target.metal = target.metal - loadedMetal;
                } else {
                    loadedMetal = loadedMetal + target.metal;
                    target.metal = 0;
                }
                rest = rest - loadedMetal;
            }
            
            if (target.crystal > 0 & rest > 0){
                if (target.crystal > 0.5*rest){
                    loadedCrystal = loadedCrystal + (int) (0.5 * rest);
                    target.crystal = target.crystal - loadedCrystal;
                } else {
                    loadedCrystal = loadedCrystal + target.crystal;
                    target.crystal = 0;
                }
                rest = rest - loadedCrystal;
            }
            
            if (target.deuterium > 0 & rest > 0){
                if (target.deuterium > rest){
                    loadedDeuterium = loadedDeuterium + rest;
                    target.deuterium = target.deuterium - loadedDeuterium;
                } else {
                    loadedDeuterium = loadedDeuterium + target.deuterium;
                    target.deuterium = 0;
                }
                rest = rest - loadedDeuterium;
            }
        }
    }
    
    public void unloadLoot(){
        Ressources.metal = Ressources.metal + loadedMetal;
        Ressources.crystal = Ressources.crystal + loadedCrystal;
        Ressources.deuterium = Ressources.deuterium + loadedDeuterium;
        
        Ressources.totalMetal = Ressources.totalMetal + loadedMetal;
        Ressources.totalCrystal = Ressources.totalCrystal + loadedCrystal;
        Ressources.totalDeuterium = Ressources.totalDeuterium + loadedDeuterium;
        
        Ressources.lootedMetal = Ressources.lootedMetal + loadedMetal;
        Ressources.lootedCrystal = Ressources.lootedCrystal + loadedCrystal;
        Ressources.lootedDeuterium = Ressources.lootedDeuterium + loadedDeuterium;
        
        loadedMetal = 0;
        loadedCrystal = 0;
        loadedDeuterium = 0;
    }
    
    
    public Fleet(){
        super();
    }
    
    
}
