
package GamePackage;

import BuildingPackage.*;
import FightPackage.*;
import ResearchPackage.*;
import ShipPackage.*;
import javax.swing.SwingUtilities;


public class Countdown extends Thread{
    @Override public void run(){
    
    }
    
    public static void runTime(){
        SwingUtilities.invokeLater(new Runnable() {
            @Override
            public void run(){
                new Thread() {
                    @Override public void run() {
                        runTimeAction();
                    }
                }.start();
            }
        });
    }
    
    static void runTimeAction(){
        int rndmTime = -1;
        int cooldown = Event.cooldown; 
        
        for (int i = 1;  i > 0; i++ ){
            GUI.gameTimeLabel.setText(Tools.convertTime((int) (Tools.getDate() - Tools.gameStart)));
            
            Ressources.metal = Ressources.metal + Ressources.metalProd;
            Ressources.totalMetal = Ressources.totalMetal + Ressources.metalProd;
            GUI.metalLabel.setText(Tools.convertNumber(Math.floor(Ressources.metal)));
            GUI.totalMetalLabel.setText(Tools.convertNumber(Math.floor(Ressources.totalMetal)));
            GUI.enemyMetalLabel.setText(Tools.convertNumber(Ressources.lootedMetal));
            
            Ressources.crystal = Ressources.crystal + Ressources.crystalProd;
            Ressources.totalCrystal = Ressources.totalCrystal + Ressources.crystalProd;
            GUI.crystalLabel.setText(Tools.convertNumber(Math.floor(Ressources.crystal)));
            GUI.totalCrystalLabel.setText(Tools.convertNumber(Math.floor(Ressources.totalCrystal)));
            GUI.enemyCrystalLabel.setText(Tools.convertNumber(Ressources.lootedCrystal));
            
            Ressources.deuterium = Ressources.deuterium + Ressources.deuteriumProd;
            Ressources.totalDeuterium = Ressources.totalDeuterium + Ressources.deuteriumProd;
            GUI.deuteriumLabel.setText(Tools.convertNumber(Math.floor(Ressources.deuterium)));
            GUI.totalDeuteriumLabel.setText(Tools.convertNumber(Math.floor(Ressources.totalDeuterium)));
            GUI.enemyDeuteriumLabel.setText(Tools.convertNumber(Ressources.lootedDeuterium));
 
            Tools.unlockButton();
            Tools.unlockGameObject();
            
            //EventHandler
            cooldown--;
            //System.out.println("Cooldown: " + String.valueOf(cooldown));
            if (cooldown == 0){
                //System.out.println("Random-Time gesetzt");
                rndmTime = (int)(Math.random() * Event.cooldown-1)+1;
                cooldown = Event.cooldown;
            }
            rndmTime--;
            //System.out.println("rndmTimern: " + String.valueOf(rndmTime));
            if (rndmTime == 0){
                //System.out.println("Event gestartet");
                Event.eventManager();    
            }

            
            if (Fleet.fleetList.size() > 0){
                if (GUI.fleetList.isSelectionEmpty()){
                    Fleet.fleetList.get(0).publish();
                } else {
                Fleet.fleetList.get(GUI.fleetList.getSelectedIndex()).publish();
                }
            }
            
            try {
                Thread.sleep(1000);
            } catch ( InterruptedException e ) {}
        }
    }
    

    public static void timerStart(GameObject obj){
       
        SwingUtilities.invokeLater(new Runnable() {
            @Override
            public void run(){
                new Thread() {
                    @Override public void run() {
                        timerAction(obj);
                    }
                }.start();
            }
        });
    }
        
    static void timerAction(GameObject obj){
        //Buildings and Research
        if (Building.class.isInstance(obj) | Research.class.isInstance(obj)){
            obj.inProgress=true;
            int i;
            if (obj.currentTime > 0){
                i = obj.currentTime;
            }
            else {
                i = obj.time;
            }
            for (obj.currentTime = i;  obj.currentTime > 0; obj.currentTime-- ){
                obj.button.setText(Tools.convertTime(obj.currentTime));
                try {
                    Thread.sleep(1000);
                } catch ( InterruptedException e ) {}
            }
            Tools.upDate(obj);
            Tools.setPoints();
        }  
        //Ships
        else {
            obj.textField.setText("0");
            for (int i = obj.numberToBuild; i > 0; i--){
                Tools.setTime(obj);
                obj.inProgress=true;
                int j;
                if (obj.currentTime > 0){
                    j = obj.currentTime;
                }
                else {
                    j = obj.time;
                }
                for (obj.currentTime = j;  obj.currentTime > 0; obj.currentTime-- ){
                    GUI.shipyardCurrentTimeLabel.setText(Tools.convertTime(obj.currentTime));
                    GUI.shipyardOverallTimeLabel.setText(Tools.convertTime(Ship.getShipyardProductionTime()));
                    try {
                        Thread.sleep(1000);
                    } catch ( InterruptedException e ) {}
                }
                Ship.increaseShipNumber(obj, 1);
                obj.inProgress=false;
                //Decrease Queue-Number
                if (Ship.numberList.get(0) > 0) 
                    Ship.numberList.set(0, Ship.numberList.get(0)-1);
                Ship.shipyardBuildList.set(0, Ship.shipyardList.get(0).name + "  (" + Ship.numberList.get(0) + ")");
                Fleet.setAvailableFleet();
                Output.shipyardReport();
                obj.currentTime = 0;
                Ship.getNextShip();
                Tools.setPoints();
            }
        }
    }
    
    
    public static void flightTimer(Fleet newFleet){
        SwingUtilities.invokeLater(new Runnable() {
            @Override
            public void run(){
                new Thread() {
                    @Override public void run() {
                        flightTimerAction(newFleet);
                    }
                }.start();
            }
        });
    }
    
    static void flightTimerAction(Fleet newFleet){
        
            int i;
            if (newFleet.currentFlightTime > 0){
                i = newFleet.currentFlightTime;
            }
            else {
                i = newFleet.flightTime;
            }
            if (newFleet.returning == false){
                for (newFleet.currentFlightTime = i;  newFleet.currentFlightTime > 0; newFleet.currentFlightTime-- ){
                    try {
                        Thread.sleep(1000);
                    } catch ( InterruptedException e ) {}
                }
                Tools.startFight(newFleet, newFleet.target);
            } else {
                for (newFleet.currentFlightTime = i;  newFleet.currentFlightTime > 0; newFleet.currentFlightTime-- ){
                    try {
                        Thread.sleep(1000);
                    } catch ( InterruptedException e ) {}
                }
                Tools.dockingProcedure(newFleet);
            }
            
    }  
    

   
}
