
package GamePackage;

import BuildingPackage.*;
import FightPackage.*;
import ResearchPackage.*;
import ShipPackage.*;
import java.io.*;
import java.util.Scanner;


public class Output {
    
    static File file = new File("BoA_savegame.txt");
    
    public static void report(GameObject obj){
        GUI.buildingNumberLabel.setText(String.valueOf(Building.getNumber()));
        GUI.researchNumberLabel.setText(String.valueOf(Research.getNumber()));
        GUI.shipNumberLabel.setText(Tools.convertNumber(Ship.getNumber()));
        
        GUI.maxBuildingNumberLabel.setText(String.valueOf(Building.maxNumber));
        GUI.energyLabel.setText(Tools.convertNumber(Ressources.energy));
        GUI.productivityLabel.setText(String.valueOf((int)Ressources.reduceFactor)+ " %");
        obj.textArea.setText(obj.toString());
        //GUI.testLabel.setText(String.valueOf((int)Event.border()));
    }
    
    public static void shipyardReport(){
        GUI.shipyardCurrentTimeLabel.setText(Tools.convertTime(0));
        GUI.shipyardOverallTimeLabel.setText(Tools.convertTime(Ship.getShipyardProductionTime()));
        GUI.shipyardProduction.setListData(Ship.shipyardBuildList.toArray());
        GUI.availableFleetList.setListData(Fleet.availableFleetReportList.toArray());
    }
    
    static void fleetReport(){
        GUI.currentFleetNumberLabel.setText(String.valueOf(FleetSlot.numberOfFilledSlots()));
        GUI.maxFleetNumberLabel.setText(String.valueOf(FleetSlot.list.size()));
        
    }
    
    static void enemyReport(){
        GUI.enemyList.setListData(Enemy.enemyReportList.toArray());
    }

    static void reportAll(){
        for(int i=0; i < Building.list.size(); i++){
            GameObject currentObj = Building.list.get(i);
            Output.report(currentObj); 
        }
        
        for(int i=0; i < Research.list.size(); i++){
            GameObject currentObj = Research.list.get(i);
            Output.report(currentObj); 
        }
        
        for(int i=0; i < Ship.list.size(); i++){
            GameObject currentObj = Ship.list.get(i);
            Output.report(currentObj); 
        }
        shipyardReport();
        fleetReport();
        enemyReport();
    }
    
    public static void writeFile(){
        try {
            FileWriter writer = new FileWriter(file);
            
            writer.write("GameStarted: true ");
            writer.write(String.valueOf(Tools.gameStart) + " ");
            
            writer.write("Timestamp: " + String.valueOf(Tools.getDate()) + " ");
            //Ressources
            writer.write("Metal: " + String.valueOf(Ressources.metal) + " " + String.valueOf(Ressources.metalProd) + " " + String.valueOf(Ressources.totalMetal) + " " + String.valueOf(Ressources.lootedMetal) + " " +
                        "Crystal: " + String.valueOf(Ressources.crystal) + " " + String.valueOf(Ressources.crystalProd) + " " + String.valueOf(Ressources.totalCrystal) + " " + String.valueOf(Ressources.lootedCrystal) + " " +
                        "Deuterium: " + String.valueOf(Ressources.deuterium) + " " + String.valueOf(Ressources.deuteriumProd) + " " +String.valueOf(Ressources.totalDeuterium) + " " + String.valueOf(Ressources.lootedDeuterium) + " " );
            
            //Buildings
            for (int i = 0; i < Building.list.size(); i++){
                GameObject currentObj = Building.list.get(i);
                writer.write( currentObj.name +": " 
                            + currentObj.stage + " " 
                            + currentObj.inProgress + " "
                            + currentObj.currentTime + " ");
            }
            
            //Research
            for (int i = 0; i < Research.list.size(); i++){
                GameObject currentObj = Research.list.get(i);
                writer.write( currentObj.name +": " 
                            + currentObj.stage + " " 
                            + currentObj.inProgress + " "
                            + currentObj.currentTime + " ");
            }
  
            //Ships
            for (int i = 0; i < Ship.list.size(); i++){
                GameObject currentObj = Ship.list.get(i);
                writer.write( currentObj.name +": " 
                            + currentObj.number + " "
                            + currentObj.lostTotal +" "
                            + Enemy.lostShips.get(i) +" ");
            }
            
            //ShipyardProduction
            if (Building.shipyard.isWorking == false){
                writer.write( "ShipyardIsWorking: false ");
            } else{
                writer.write( "ShipyardIsWorking: true "
                            + "ShipyardListSize: " + Ship.shipyardList.size() + " ");
                for (int i = 0; i < Ship.shipyardList.size(); i++){
                    writer.write( "ToBuild_"+i+": " + Ship.shipyardList.get(i).name + " " + Ship.numberList.get(i) + " " + Ship.shipyardList.get(i).currentTime + " ");
                }
            }
            
            //Enemies
            writer.write("EnemyListSize: " + Enemy.enemyList.size() + " ");
            for (int i = 0; i < Enemy.enemyList.size(); i++){
                Enemy currentEnemy = Enemy.enemyList.get(i);
                int eShipInFleetListSize = currentEnemy.eShipInFleetList.size();
                writer.write( "EnemyStage_"+currentEnemy.stage+": " + "eShipInFleetListSize: " + eShipInFleetListSize + " ");
                for (int j = 0; j < eShipInFleetListSize; j++){
                    Ship currentShip = currentEnemy.eShipInFleetList.get(j);
                    writer.write(currentShip.name + " " + currentShip.number + " ");
                }
                writer.write ( "Spied: " + currentEnemy.spied + " " +  "Targeted: " + currentEnemy.targeted + " " );
            }
            
            //FleetSlot
                writer.write( "FleetSlotNumber: " + FleetSlot.list.size() + " ");
            
            //Fleet
            writer.write( "FleetListSize: " + Fleet.fleetList.size() + " "
                        + "StaticFleedID: " + Fleet.static_ID + " ");
            if (Fleet.fleetList.size() > 0){
                for (int i = 0; i < Fleet.fleetList.size(); i++){
                    Fleet currentFleet = Fleet.fleetList.get(i);
                    writer.write("TargetStage: " + currentFleet.target.stage + " "
                                + "FleetID: " + currentFleet.ID + " " 
                                + "CurrentFlightTime: " + currentFleet.currentFlightTime + " "
                                + "FlightTime: " + currentFleet.flightTime + " "
                                + "Returning: " + currentFleet.returning + " ");
                    if (currentFleet.returning == true ){
                        writer.write("LoadedMetal: " + currentFleet.loadedMetal + " "
                                + "LoadedCrystal: " + currentFleet.loadedCrystal + " "
                                + "LoadedDeuterium: " + currentFleet.loadedDeuterium + " ");
                    }
                    writer.write("ShipListSize: " + currentFleet.shipList.size() + " ");
                    for (int j = 0; j < currentFleet.shipList.size(); j++){
                        writer.write(currentFleet.shipList.get(j).name + " " + currentFleet.shipNumberList.get(j) + " ");
                    }
                }
            }
            
            //Statistics
            writer.write("Fights: " +Tools.totalFights +" " +Tools.fightsWon +" " +Tools.fightsLost +" " +Tools.fightsDrawn +" " + Ship.totalLostShips + " " +Enemy.totalLostShips);            
            
            writer.flush();
            writer.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    
    public static void readFile() {
        FileReader fr;
        BufferedReader br;
        Scanner sc;
        try {
            fr = new FileReader(file);
            br = new BufferedReader(fr);
            
            String zeile;
            zeile = br.readLine();
            sc = new Scanner(zeile);
            while (zeile != null) {
                sc.findInLine("GameStarted:");
                Tools.gameStarted = Boolean.parseBoolean(sc.next());
                Tools.gameStart = Double.parseDouble(sc.next());
                sc.findInLine("Timestamp:");
                Tools.timestamp = Double.parseDouble(sc.next());
                
                //Ressources
                sc.findInLine("Metal:");
                Ressources.metal = Double.parseDouble(sc.next());
                Ressources.metalProd = Double.parseDouble(sc.next());
                Ressources.totalMetal = Double.parseDouble(sc.next());
                Ressources.lootedMetal = Double.parseDouble(sc.next());
                sc.findInLine("Crystal:");
                Ressources.crystal = Double.parseDouble(sc.next());
                Ressources.crystalProd = Double.parseDouble(sc.next());
                Ressources.totalCrystal = Double.parseDouble(sc.next());
                Ressources.lootedCrystal = Double.parseDouble(sc.next());
                sc.findInLine("Deuterium:");
                Ressources.deuterium = Double.parseDouble(sc.next());
                Ressources.deuteriumProd = Double.parseDouble(sc.next());
                Ressources.totalDeuterium = Double.parseDouble(sc.next());
                Ressources.lootedDeuterium = Double.parseDouble(sc.next());
                
                //Buildings
                for(int i=0; i < Building.list.size(); i++){
                    GameObject currentObj = Building.list.get(i);
                    sc.findInLine(currentObj.name + ":");
                    currentObj.stage = Integer.parseInt(sc.next());
                    currentObj.inProgress = Boolean.parseBoolean(sc.next());
                    currentObj.currentTime = Integer.parseInt(sc.next());
                }  
                
                //Research
                for(int i=0; i < Research.list.size(); i++){
                    GameObject currentObj = Research.list.get(i);
                    sc.findInLine(currentObj.name + ":");
                    currentObj.stage = Integer.parseInt(sc.next());
                    currentObj.inProgress = Boolean.parseBoolean(sc.next());
                    currentObj.currentTime = Integer.parseInt(sc.next());
                }

                //Ships
                for(int i=0; i < Ship.list.size(); i++){
                    Ship currentShip = Ship.list.get(i);
                    sc.findInLine(currentShip.name + ":");
                    currentShip.number = Integer.parseInt(sc.next());
                    currentShip.lostTotal = Long.parseLong(sc.next());
                    Enemy.lostShips.add(Long.parseLong(sc.next()));
                    GUI.lostTextArea.append(currentShip.name + ": " +Tools.convertNumber(currentShip.lostTotal) + " / " + Tools.convertNumber(Enemy.lostShips.get(i))+ "\n");
                }
                
                //ShipyardProduction
                sc.findInLine("ShipyardIsWorking: ");
                if(sc.next().equals("true")){
                    sc.findInLine("ShipyardListSize: ");
                    int ShipyardListsize = Integer.parseInt(sc.next());
                    for(int i=0; i <ShipyardListsize; i++){
                        sc.findInLine("ToBuild_"+i+":");
                        if (sc.hasNext() == true){
                            Ship.shipyardList.add(i, Tools.getObjByName(sc.next()));
                            Ship.numberList.add(Integer.parseInt(sc.next()));
                            Ship.shipyardList.get(i).numberToBuild = Ship.numberList.get(i);
                            Ship.shipyardList.get(i).currentTime = Integer.parseInt(sc.next());
                            Ship.shipyardList.get(0).inProgress = true;
                            Ship.shipyardBuildList.add(Ship.shipyardList.get(i).name + "  (" + Ship.numberList.get(i) + ")");
                        }
                    }
                }
                
                //Enemies
                sc.findInLine("EnemyListSize: ");
                int enemyListSize = Integer.parseInt(sc.next());
                for (int i = 0; i < enemyListSize; i++){
                    sc.findInLine("EnemyStage_"+i+":");
                    if (sc.hasNext()==true){
                        Enemy newEnemy = new Enemy();
                        Enemy.newEnemy(newEnemy);

                        //Zero-ing the Enemy ShipLists (Number in eShipList, Ships in inFleetList
                        for (int j = 0; j < newEnemy.eShipList.size(); j++){
                            newEnemy.eShipList.get(j).number = 0;                                
                        }
                        newEnemy.eShipInFleetList.clear();
                        
                        sc.findInLine("eShipInFleetListSize:");
                        int eShipInFleetListSize = Integer.parseInt(sc.next());
                        for (int j = 0; j < eShipInFleetListSize; j++){
                           Ship newShip = newEnemy.getShipByName(sc.next());
                           newShip.number = Integer.parseInt(sc.next());
                           newEnemy.eShipInFleetList.add(newShip);
                        }
                        newEnemy.setEnemyShipValues();
                        sc.findInLine("Spied:");
                        newEnemy.spied = Boolean.parseBoolean(sc.next());
                        sc.findInLine("Targeted:");
                        newEnemy.targeted = Boolean.parseBoolean(sc.next());
                        newEnemy.publish();
                    }  
                }
                
                sc.findInLine("FleetSlotNumber: ");
                int fleetSlotNumber = Integer.parseInt(sc.next());
                for (int i = 0; i < fleetSlotNumber; i++){
                    FleetSlot.newSlot();
                }
                
                //Fleet
                sc.findInLine("FleetListSize: ");
                int fleetListSize = Integer.parseInt(sc.next());
                sc.findInLine("StaticFleedID: ");
                Fleet.static_ID = Integer.parseInt(sc.next());
                
                for (int i = 0; i < fleetListSize; i++){
                    sc.findInLine("TargetStage: ");
                    int targetIndex = Integer.parseInt(sc.next()) - 1; 
                    Enemy enemy = Enemy.enemyList.get(targetIndex);
                    Fleet newFleet = new Fleet();
                    newFleet.attackmode = "attacking";
                    Fleet.newFleet(newFleet, enemy);

                    sc.findInLine("FleetID:");
                    newFleet.ID = Integer.parseInt(sc.next());
                    sc.findInLine("CurrentFlightTime:");
                    newFleet.currentFlightTime = Integer.parseInt(sc.next());
                    sc.findInLine("FlightTime:");
                    newFleet.flightTime = Integer.parseInt(sc.next());
                    sc.findInLine("Returning:");
                    newFleet.returning = Boolean.parseBoolean(sc.next());
                    if (newFleet.returning == true){
                        sc.findInLine("LoadedMetal: ");
                        newFleet.loadedMetal = Double.parseDouble(sc.next());
                        sc.findInLine("LoadedCrystal: ");
                        newFleet.loadedCrystal = Double.parseDouble(sc.next());
                        sc.findInLine("LoadedDeuterium: ");
                        newFleet.loadedDeuterium = Double.parseDouble(sc.next());
                    }
                    sc.findInLine("ShipListSize: ");
                    int shipListSize = Integer.parseInt(sc.next());
                   
                    for (int j = 0; j < shipListSize; j++){
                        Ship newShip = (Ship) Tools.getObjByName(sc.next());
                        newFleet.shipList.add(newShip);
                        newFleet.shipNumberList.add(Integer.parseInt(sc.next()));
                    }
                    Fleet.fleetReportList.add("Fleet " + newFleet.ID + ": "+ Tools.convertTime(newFleet.flightTime));
                }
                if (fleetListSize > 0)
                    GUI.fleetList.setListData(Fleet.fleetReportList.toArray());
                
                //Statistics
                sc.findInLine("Fights: ");
                Tools.totalFights = Integer.parseInt(sc.next());
                Tools.fightsWon = Integer.parseInt(sc.next());
                Tools.fightsLost = Integer.parseInt(sc.next());
                Tools.fightsDrawn = Integer.parseInt(sc.next());
                Ship.totalLostShips = Long.parseLong(sc.next());
                Enemy.totalLostShips = Long.parseLong(sc.next());
                
                GUI.totalFightsLabel.setText(Tools.convertNumber(Tools.totalFights));
                GUI.fightsWonLabel.setText(Tools.convertNumber(Tools.fightsWon));
                GUI.fightsLostLabel.setText(Tools.convertNumber(Tools.fightsLost));
                GUI.fightsDrawnLabel.setText(Tools.convertNumber(Tools.fightsDrawn));
                GUI.totalLostShipLabel.setText(Tools.convertNumber(Ship.totalLostShips) + " / " + Tools.convertNumber(Enemy.totalLostShips));
                
                zeile = br.readLine();
            }
            fr.close();
        }
        catch (IOException e){
            Tools.timestamp = 0;
            Tools.gameStart = Tools.getDate();
            Enemy.newEnemy(new Enemy());
            System.out.println("Die Datei " + file +" ist noch nicht verhanden.");
            System.out.println(e.toString());
            
            for(int i=0; i < Ship.list.size(); i++){
                Ship currentShip = Ship.list.get(i);
                long a = 0;
                Enemy.lostShips.add(a);
                GUI.lostTextArea.append(currentShip.name + ": " +Tools.convertNumber(currentShip.lostTotal) + " / " + Tools.convertNumber(Enemy.lostShips.get(i))+ "\n");
            }
            
        }
        }

    }
    
    
    

