
package GamePackage;

import BuildingPackage.*;
import static BuildingPackage.Building.*;
import FightPackage.*;
import static FightPackage.Enemy.enemyReportList;
import ResearchPackage.*;
import static ResearchPackage.Research.*;
import ShipPackage.*;
import static ShipPackage.Ship.*;
import java.text.DecimalFormat;
import java.util.*;

public class Tools {
 
    //GameStart
    static void startGame(){
        addObjects();
        Output.readFile();
        setElapsedProduction();
        Fleet.setAvailableFleet();
        updateAll();
        Building.setMaxNumber(terraformer);
        Output.reportAll();
        //GUI.fleetList.setListData(Fleet.fleetReportList.toArray());
        lockGameObject();
        setPoints();
        Countdown.runTime();
        GUI.addShipButton.setEnabled(false);
        GUI.removeShipButton.setEnabled(false);
        GUI.targetPanel.setVisible(true);
    }
    
    static void addObjects(){
        Building.add();
        Research.add();
        Ship.add();
    }
    
    static boolean gameStarted = false;
    static double gameStart;
    
    static void setElapsedProduction(){
        double elapsedTime; 
        if (timestamp == 0){
            elapsedTime = 0;
        }
        else {
            elapsedTime = getDate() - timestamp;
        }
        GUI.testLabel.setText("Offline since: " + convertTime((int) elapsedTime));
        
        //Ressources
        Ressources.metal = Ressources.metal + Ressources.metalProd * elapsedTime;
        Ressources.crystal = Ressources.crystal + Ressources.crystalProd * elapsedTime;
        Ressources.deuterium = Ressources.deuterium + Ressources.deuteriumProd * elapsedTime;
        
        Ressources.totalMetal = Ressources.totalMetal + Ressources.metalProd * elapsedTime;
        Ressources.totalCrystal = Ressources.totalCrystal + Ressources.crystalProd * elapsedTime;
        Ressources.totalDeuterium = Ressources.totalDeuterium + Ressources.deuteriumProd * elapsedTime;
        
        //Buildings
        for(int i=0; i < Building.list.size(); i++){
            GameObject currentObj = Building.list.get(i);
            if (currentObj.inProgress == true){
                currentObj.currentTime = (int) (currentObj.currentTime - elapsedTime);

                if (currentObj.currentTime <= 0) {
                    currentObj.currentTime = 0;
                    upDate(currentObj);
                } else {
                    Countdown.timerStart(currentObj);   
                }
            }
        }
        
        //Research
        for(int i=0; i < Research.list.size(); i++){
            GameObject currentObj = Research.list.get(i);
            if (currentObj.inProgress == true){
                currentObj.currentTime = (int) (currentObj.currentTime - elapsedTime);

                if (currentObj.currentTime <= 0) {
                    currentObj.currentTime = 0;
                    upDate(currentObj);
                } else {
                    Countdown.timerStart(currentObj);   
                }
            }
        }

        //Shipyard
        int run = 0;
        int totalTime;
        int shipsBuilt = 0;
        double totalRemainingTime;
        double elapsedTimeForShipyard = elapsedTime;
        while (elapsedTimeForShipyard > 0){
            if (shipyardList.size()<=0){
                shipyard.isWorking=false;
                break;
            }
            else{
            GameObject currentObj = shipyardList.get(0);
                setTime(currentObj);
                if (run == 0){
                    totalTime = currentObj.currentTime + currentObj.time * (numberList.get(0)-1);
                    run =1;
                }
                else{
                    totalTime = currentObj.time * (numberList.get(0));
                }
                totalRemainingTime = elapsedTimeForShipyard - totalTime;
                if (totalRemainingTime > 0){
                    shipsBuilt = numberList.get(0);
                    numberList.remove(0);
                    shipyardList.remove(0);
                    shipyardBuildList.remove(0);
                    increaseShipNumber(currentObj, shipsBuilt);
                    elapsedTimeForShipyard = totalRemainingTime;
                    currentObj.currentTime = 0;
                }
                else{
                    totalRemainingTime = totalTime - elapsedTimeForShipyard;
                    int leftNumberToBuild =  (int) Math.ceil(totalRemainingTime / currentObj.time);
                    shipsBuilt = numberList.get(0) - leftNumberToBuild;
                    if (shipsBuilt >0)
                        increaseShipNumber(currentObj, shipsBuilt);
                    numberList.set(0, leftNumberToBuild);
                    if (leftNumberToBuild == 1){
                        currentObj.currentTime = (int) (totalRemainingTime % (leftNumberToBuild * currentObj.time));   
                    } else {
                        currentObj.currentTime = (int) (totalRemainingTime % ((leftNumberToBuild-1) * currentObj.time));
                    }
                    shipyardBuildList.set(0, currentObj.name + "  (" + numberList.get(0) + ")");
                    
                    elapsedTimeForShipyard = 0;
                }
            } 
        }
        Ship.getNextShip();
        
        //Flight
        if (Fleet.fleetList.size() > 0){
            for (int i = 0; i < Fleet.fleetList.size(); i++){
                Fleet currentFleet = Fleet.fleetList.get(i);
                if (currentFleet.returning == false){
                    if (elapsedTime >= currentFleet.currentFlightTime){
                        int remainingElapsedTime = (int) (elapsedTime - currentFleet.currentFlightTime);
                        currentFleet.resumed = true;
                        Tools.startFight(currentFleet, currentFleet.target);
                        if (remainingElapsedTime > currentFleet.flightTime && currentFleet.shipList.size() > 0){
                            dockingProcedure(currentFleet);
                            i--;
                        } else if (currentFleet.shipList.size() > 0){
                            currentFleet.currentFlightTime = currentFleet.flightTime - remainingElapsedTime;
                            Countdown.flightTimer(currentFleet);
                        }
                        
                    } else {
                        currentFleet.currentFlightTime = (int) (currentFleet.currentFlightTime - elapsedTime);
                        Countdown.flightTimer(currentFleet);
                    }
                } else {
                    if (elapsedTime > currentFleet.currentFlightTime){
                        dockingProcedure(currentFleet);
                        i--;
                    } else {
                        currentFleet.currentFlightTime = (int) (currentFleet.currentFlightTime - elapsedTime);
                        Countdown.flightTimer(currentFleet);
                    }
                }
            }
            GUI.fleetList.setListData(Fleet.fleetReportList.toArray());
        }
        
        //EventManager
        int numberOfEvents = (int)(elapsedTime / Event.cooldown);
        for (int i = numberOfEvents; i > 0; i--){
            Event.eventManager();
        }
    }

    static void setPoints(){
        double totalPoints = 0;
        double buildingPoints = 0;
        double researchPoints = 0;
        double shipPoints = 0;
       
        for(int i = 0; i < Building.list.size(); i++){
            Building currentBuilding = Building.list.get(i);
            for (int j=1; j <= currentBuilding.stage; j++){
                buildingPoints =  buildingPoints + (Math.round(currentBuilding.metalStartCost * Math.pow(currentBuilding.costFactor, j)* Math.pow(0.8, ressourceEng.stage)+
                                              currentBuilding.crystalStartCost * Math.pow(currentBuilding.costFactor, j)* Math.pow(0.8, ressourceEng.stage)+
                                              currentBuilding.deuteriumStartCost * Math.pow(currentBuilding.costFactor, j)* Math.pow(0.8, ressourceEng.stage)))/1000.0;
            }
        }
        
        for(int i = 0; i < Research.list.size(); i++){
            GameObject currentObj = Research.list.get(i);
            for (int j=1; j <= currentObj.stage; j++){
                researchPoints =  researchPoints + (Math.round(currentObj.metalStartCost * Math.pow(currentObj.costFactor, j)* Math.pow(0.8, ressourceEng.stage)+
                                              currentObj.crystalStartCost * Math.pow(currentObj.costFactor, j)* Math.pow(0.8, ressourceEng.stage)+
                                              currentObj.deuteriumStartCost * Math.pow(currentObj.costFactor, j)* Math.pow(0.8, ressourceEng.stage)))/1000.0;
            }
        }
        
        for(int i = 0; i < Ship.list.size(); i++){
            Ship currentShip = Ship.list.get(i);
           // for (int j=1; j <= currentShip.number; j++){
                shipPoints =  shipPoints + (currentShip.number * Math.round(currentShip.metalCost + currentShip.crystalCost + currentShip.deuteriumCost))/1000.0;
            //}
        }
        
        if (Fleet.fleetList.size() > 0){
            for (int i = 0; i < Fleet.fleetList.size(); i++){
                Fleet currentFleet = Fleet.fleetList.get(i);
                //if (currentFleet.returning == true){
                    for (int j = 0; j < currentFleet.shipList.size(); j++){
                        Ship currentShip = currentFleet.shipList.get(j);
                        int shipNumber = currentFleet.shipNumberList.get(j);
                        shipPoints = shipPoints + (Math.round(currentShip.metalCost * shipNumber + currentShip.crystalCost * shipNumber + currentShip.deuteriumCost * shipNumber))/1000.0;
                    }
                //}
            }
        }
        
        totalPoints = buildingPoints + researchPoints + shipPoints;
        
        GUI.buildingPointLabel.setText(convertNumber(buildingPoints));
        GUI.researchPointLabel.setText(convertNumber(researchPoints));
        GUI.shipPointLabel.setText(convertNumber(shipPoints));
        GUI.pointLabel.setText(convertNumber(totalPoints));
    }
    
    static void updateAll(){
        for(int i=0; i < Building.list.size(); i++){
            GameObject currentObj = Building.list.get(i);
            setCosts(currentObj);
            setTime(currentObj);
            setEnergyProd(currentObj);
            setEnergyConsumption(currentObj);
            setProductionRate(currentObj);   
        }
            
        for(int i=0; i < Research.list.size(); i++){
            GameObject currentObj = Research.list.get(i);
            setCosts(currentObj);
            setTime(currentObj);
        }
            
        for(int i=0; i < Ship.list.size(); i++){
            GameObject currentObj = Ship.list.get(i);
            setShipValues(currentObj);
            setTime(currentObj);
        }
    }
      
    static void lockGameObject(){    
        //Buildings
        GUI.shipyardButton.setVisible(false);
        GUI.naniteButton.setVisible(false);
        GUI.portalButton.setVisible(false);
        GUI.terraformerButton.setVisible(false);
        GUI.fusionButton.setVisible(false);
        GUI.machineryButton.setVisible(false);
        //Research
        GUI.energyButton.setVisible(false);
        GUI.computerButton.setVisible(false); 
        GUI.combustionButton.setVisible(false);
        GUI.impulseButton.setVisible(false); 
        GUI.spyButton.setVisible(false);
        GUI.weaponButton.setVisible(false);
        GUI.longRangeButton.setVisible(false);
        GUI.ressourceEngButton.setVisible(false);
        GUI.intergalacticButton.setVisible(false);            
        GUI.hyperspaceDriveButton.setVisible(false);
        GUI.armorButton.setVisible(false);            
        GUI.shieldButton.setVisible(false);
        //Ships
        GUI.battleShipButton.setVisible(false);
        GUI.dreadnoughtButton.setVisible(false);
        GUI.cruiserButton.setVisible(false);
        GUI.destroyerButton.setVisible(false);
        GUI.lightFighterButton.setVisible(false);
        GUI.heavyFighterButton.setVisible(false);
        GUI.largeTransporterButton.setVisible(false);
        GUI.smallTransporterButton.setVisible(false);
        GUI.spyDroneButton.setVisible(false);
    }
    
    //Building Process
    static boolean isAffordable(GameObject obj){
        if (Ship.class.isInstance(obj)){ 
            int numberToBuild;
            if (obj.textField.getText().equals(""))
                numberToBuild = 0;
            else
                numberToBuild = Integer.parseInt(obj.textField.getText());
            return ((obj.metalCost * numberToBuild) <= Ressources.metal) & ((obj.crystalCost * numberToBuild) <= Ressources.crystal) & ((obj.deuteriumCost * numberToBuild) <= Ressources.deuterium);
        } 
        else {
            setCosts(obj);
            return obj.metalCost <= Ressources.metal && obj.crystalCost <= Ressources.crystal && obj.deuteriumCost <= Ressources.deuterium;
        }
    }     
    
    static void unlockButton(){
        GameObject currentObj;
        for(int i=0; i < Building.list.size(); i++){
            currentObj = Building.list.get(i);
            if (currentObj.inProgress == false & isAffordable(currentObj)==true){
                currentObj.button.setEnabled(true);
            } 
            else {
                currentObj.button.setEnabled(false);
                if (currentObj.inProgress==false)
                    currentObj.button.setText("T- " +convertTime(timeTillAffordable(currentObj)));
            }
        }
        
        for(int i=0; i < Research.list.size(); i++){
            currentObj = Research.list.get(i);
            if (currentObj.inProgress == false & isAffordable(currentObj)==true){
                currentObj.button.setEnabled(true);
            }
            else {
                currentObj.button.setEnabled(false);
                if (currentObj.inProgress==false)
                    currentObj.button.setText("T- " +convertTime(timeTillAffordable(currentObj)));
            }
        }
        
        for(int i=0; i < Ship.list.size(); i++){
            currentObj = Ship.list.get(i);
            if (isAffordable(currentObj)==true){
                currentObj.button.setEnabled(true);
            }
            else {
                currentObj.button.setEnabled(false);
            }
        }
    }
    
    public static void payProduction(GameObject obj){
        int numberToBuild = 1;
        if (Ship.class.isInstance(obj))
            numberToBuild = Integer.parseInt(obj.textField.getText());
        Ressources.metal = Ressources.metal - obj.metalCost * numberToBuild;
        Ressources.crystal = Ressources.crystal - obj.crystalCost * numberToBuild;
        Ressources.deuterium = Ressources.deuterium - obj.deuteriumCost * numberToBuild;
    }
    
    public static void startProduction(GameObject obj){
        if (Building.class.isInstance(obj) | Research.class.isInstance(obj)){
            //Tools.setValues(obj);
            Building.setMaxNumber(obj);
            if (Building.maxNumber > Building.getNumber()){
                payProduction(obj);
                Countdown.timerStart(obj);
            }     
        }
        else if (Ship.class.isInstance(obj)){

            if (numberList.get(0) > 0 & shipyard.isWorking == false){
                shipyard.isWorking = true;
                Countdown.timerStart(obj);
            } 
            else if (numberList.get(0) == 0){
                shipyard.isWorking = false;
                shipyardList.remove(0);
                shipyardBuildList.remove(0);
                numberList.remove(0);
                Output.shipyardReport();
                getNextShip();
            }
        }
    }
    
    public static void setValues(GameObject obj){
        setCosts(obj);
        setTime(obj);
        Building.setMaxNumber(obj);
        Building.setEnergyProd(obj);
        Building.setEnergyConsumption(obj);
        Building.setProductionRate(obj);
        Ship.setShipValues(obj);
        setFleetSlots(obj);
    }
    
    public static void setCosts(GameObject obj){
        if (Building.class.isInstance(obj)){
            obj.metalCost =  Math.round(obj.metalStartCost * Math.pow(obj.costFactor, obj.stage+1)* Math.pow(0.8, ressourceEng.stage));
            obj.crystalCost = Math.round(obj.crystalStartCost* Math.pow(obj.costFactor, obj.stage+1)* Math.pow(0.8, ressourceEng.stage));
            obj.deuteriumCost = Math.round(obj.deuteriumStartCost* Math.pow(obj.costFactor, obj.stage+1)* Math.pow(0.8, ressourceEng.stage));
        }
        else{
            obj.metalCost =  Math.round(obj.metalStartCost * Math.pow(obj.costFactor, obj.stage+1));
            obj.crystalCost = Math.round(obj.crystalStartCost* Math.pow(obj.costFactor, obj.stage+1));
            obj.deuteriumCost = Math.round(obj.deuteriumStartCost* Math.pow(obj.costFactor, obj.stage+1));    
        }
    }
        
    public static void setTime(GameObject obj){

        if (Building.class.isInstance(obj)){
            if (obj.equals(robotFactory) || obj.equals(naniteFactory) || obj.equals(shipyard)){
                for(int i=0; i < Building.list.size(); i++){
                    GameObject currentObj =  Building.list.get(i);
                    setCosts(currentObj);
                    currentObj.time = (int) Math.round((currentObj.metalCost + currentObj.crystalCost + currentObj.deuteriumCost)
                                                        /(2500 * timeFactor *(1+ robotFactory.stage)) * Math.pow(0.5, naniteFactory.stage)*3600); 
                    Output.report(currentObj);
                }

                for(int i=0; i < Ship.list.size(); i++){
                    GameObject currentObj = Ship.list.get(i);
                    currentObj.time = (int) Math.round((currentObj.metalCost + currentObj.crystalCost + currentObj.deuteriumCost)
                                                        /(2500 * /*timeFactor */ (1+ shipyard.stage)) * Math.pow(0.5, naniteFactory.stage)*3600);
                }
            }
            
            if (obj.equals(researchFacility)){
                for(int i=0; i < Research.list.size(); i++){
                    GameObject currentObj = Research.list.get(i);
                    setCosts(currentObj);
                    currentObj.time = (int) Math.round((currentObj.metalCost + currentObj.crystalCost + currentObj.deuteriumCost)
                                                        /(1000 * timeFactor *(1+ researchFacility.stage))*3600);
                    Output.report(currentObj);
                }
            }
            obj.time = (int) Math.round((obj.metalCost + obj.crystalCost + obj.deuteriumCost)/(2500 * timeFactor *(1+ robotFactory.stage)) * Math.pow(0.5, naniteFactory.stage)*3600); 
        }

        else if (Research.class.isInstance(obj)){
            if (obj==intergalacticResearchNetwork){
                for(int i=0; i < Research.list.size(); i++){
                    GameObject currentObj = Research.list.get(i);
                    setCosts(currentObj);
                    currentObj.time = (int) Math.round((currentObj.metalCost + currentObj.crystalCost + currentObj.deuteriumCost)
                                                        /(1000 * timeFactor *(1+ researchFacility.stage))* Math.pow(0.5, intergalacticResearchNetwork.stage)*3600);
                    Output.report(currentObj);
                }
            }
            obj.time = (int) Math.round((obj.metalCost + obj.crystalCost + obj.deuteriumCost)/(1000 * timeFactor *(1+ researchFacility.stage))* Math.pow(0.5, intergalacticResearchNetwork.stage)*3600);
            Output.report(obj);
        }

        else if (Ship.class.isInstance(obj)){    
            obj.time = (int) Math.round((obj.metalCost + obj.crystalCost + obj.deuteriumCost)/(2500 * /*timeFactor */(1+ shipyard.stage)) * Math.pow(0.5, naniteFactory.stage)*3600);
            if (obj.time <=0)
                obj.time = 1;
        }
    }
   
    static void setFleetSlots(GameObject obj){
        if (obj.equals(computerTech) && computerTech.stage%2==0 ){
            FleetSlot.newSlot();
        }
    }
    
    static void upDate(GameObject obj){
        obj.inProgress = false;
        obj.button.setText("Stage +1");
        obj.stage++;
        setValues(obj);
        unlockGameObject();
        Output.report(obj);
    }

    static void unlockGameObject(){
        //Buildings
        if (robotFactory.stage >= 2)
            GUI.shipyardButton.setVisible(true);
        
        if (robotFactory.stage >= 10 & computerTech.stage >= 10)
            GUI.naniteButton.setVisible(true);        
        
        if (shipyard.stage >= 15 & hyperspaceDrive.stage >= 10 & naniteFactory.stage >= 5)
            GUI.portalButton.setVisible(true);
        
        if (naniteFactory.stage >= 2 & energyTech.stage >= 12 & impulseTech.stage >= 10)
            GUI.terraformerButton.setVisible(true);
        
        if (deutSynth.stage >= 5 & energyTech.stage >= 3)
            GUI.fusionButton.setVisible(true);
        
        if (metalMine.stage >= 35 && crystalMine.stage >= 30 && deutSynth.stage >= 30 && robotFactory.stage >= 15 && ressourceEng.stage >= 3)
            GUI.machineryButton.setVisible(true);
       
        //Research
        if (researchFacility.stage >= 1) {
            GUI.energyButton.setVisible(true);
            GUI.computerButton.setVisible(true);           
        }
        
        if (researchFacility.stage >= 1 & energyTech.stage >=1 )
            GUI.combustionButton.setVisible(true);         
        
        if (researchFacility.stage >= 2 & energyTech.stage >=1 )
            GUI.impulseButton.setVisible(true);         
        
        if (researchFacility.stage >= 3) 
            GUI.spyButton.setVisible(true);
        
        if (researchFacility.stage >= 4) 
            GUI.weaponButton.setVisible(true);

        if (researchFacility.stage >= 15 & energyTech.stage >= 15 & intergalacticResearchNetwork.stage >= 5) 
            GUI.ressourceEngButton.setVisible(true);
        
        if (researchFacility.stage >= 5 & spyTech.stage >= 8 & energyTech.stage >= 5) 
            GUI.longRangeButton.setVisible(true);
        
        if (researchFacility.stage >= 10 & computerTech.stage >= 8 & hyperspaceDrive.stage >=8 )
            GUI.intergalacticButton.setVisible(true);
        
        if (combustionTech.stage >= 8 & impulseTech.stage >= 6)
            GUI.hyperspaceDriveButton.setVisible(true);
        
        if (researchFacility.stage >= 2) 
            GUI.armorButton.setVisible(true);
        
        if (researchFacility.stage >= 6 & energyTech.stage >= 3 )
            GUI.shieldButton.setVisible(true);
        
        //Ships
        if (shipyard.stage >= 7 & hyperspaceDrive.stage >= 4)
            GUI.battleShipButton.setVisible(true);
        
        if (shipyard.stage >= 15 & longRangeSensors.stage >= 14 & weaponTech.stage >= 16)
            GUI.dreadnoughtButton.setVisible(true);
        
        if (shipyard.stage >= 5 & impulseTech.stage >= 5)
            GUI.cruiserButton.setVisible(true);
        
        if (shipyard.stage >= 9 & hyperspaceDrive.stage >= 6)
            GUI.destroyerButton.setVisible(true);
        
        if (shipyard.stage >= 1 & impulseTech.stage >= 1 & armorTech.stage >= 2)
            GUI.lightFighterButton.setVisible(true);
        
        if (shipyard.stage >= 3 & impulseTech.stage >= 2 & armorTech.stage >= 4)
            GUI.heavyFighterButton.setVisible(true);
        
        if (shipyard.stage >= 4 & combustionTech.stage >= 6)
            GUI.largeTransporterButton.setVisible(true);
        
        if (shipyard.stage >= 2 & combustionTech.stage >= 2)
            GUI.smallTransporterButton.setVisible(true);
        
        if (shipyard.stage >= 3 & combustionTech.stage >= 3 & spyTech.stage >= 2)
            GUI.spyDroneButton.setVisible(true);
    }
    

    //Time
    public static int timeFactor = 10; 
    static double timestamp;
    
    static double getDate(){
        double actualDate = System.currentTimeMillis()/1000;
        return actualDate;
    }
    
    static int timeTillAffordable(GameObject obj){
        int time = 0;
        int metal_time=0;
        int crystal_time=0;
        int deuterium_time=0;
        
        if (obj.metalCost > 0){
            if (Ressources.metalProd > 0)
                metal_time = (int) ((obj.metalCost - Ressources.metal) / Ressources.metalProd);
            else
                return 0;
        }
        else metal_time=0;
        
        if (obj.crystalCost > 0){
            if (Ressources.crystalProd > 0)
                crystal_time = (int) ((obj.crystalCost - Ressources.crystal) / Ressources.crystalProd);
            else
                return 0;
        }
        else crystal_time=0;
                
        if (obj.deuteriumCost > 0){
            if (Ressources.deuteriumProd > 0)
                deuterium_time = (int) ((obj.deuteriumCost - Ressources.deuterium) / Ressources.deuteriumProd);
            else
                return 0;
        }
        else deuterium_time=0;
        
        time = Math.max(metal_time, Math.max(crystal_time, deuterium_time));
        
        return time;
    }
    
    public static String convertTime(int time){
        int days = (int) time / (60 * 60 * 24);
        int hours = (int) time / (60 * 60) % 24;
        int minutes = (int) time / 60 % 60;
        int seconds = (int) (time - minutes * 60 - hours * 3600) % 60;
        
        String convertTime;
        if (days > 0) {
            convertTime = String.valueOf(days + "d " +hours+"h "+minutes+"min "+seconds+"sec");
        }
        else if (hours >0 && days <=0) {
            convertTime = String.valueOf(hours+"h "+minutes+"min "+seconds+"sec");
        }
        else {
            convertTime = String.valueOf(minutes+"min "+seconds+"sec");
        }
        
        return convertTime;
    }    
    
    //General
    public static GameObject getObjByName(String name){
        GameObject obj = null;
        for(int i=0; i < Building.list.size(); i++){  
            if (name.equals(Building.list.get(i).name))
                obj = Building.list.get(i);
        }
        for(int i=0; i < Ship.list.size(); i++){
            if (name.equals(Ship.list.get(i).name))
                obj = Ship.list.get(i);
        }
        for(int i=0; i < Research.list.size(); i++){
            if (name.equals(Research.list.get(i).name))
                obj = Research.list.get(i);
        }
        return obj;
    }      

    public static String convertNumber(double number){
        DecimalFormat df = (DecimalFormat)DecimalFormat.getInstance(Locale.GERMAN);
        df.applyPattern( "#,###,###" );
        String s = df.format(number);
        return s;
    }


    //Fighting
    static void reloadShield(Fleet fleet, Enemy enemy){
        for (int i = 0; i< fleet.shipList.size(); i++){
            Ship currentShip = fleet.shipList.get(i);
            currentShip.currentShield = currentShip.shield;
        }

        for (int i = 0; i< enemy.eShipInFleetList.size(); i++){
            Ship currentShip = enemy.eShipInFleetList.get(i);
            currentShip.currentShield = currentShip.shield;
        }
    }
    
    static void setCurrentArmor(Fleet fleet, Enemy enemy){
        for (int i = 0; i< fleet.shipList.size();i++){
            Ship currentShip = fleet.shipList.get(i);
            currentShip.currentArmor = currentShip.armor;
        }
        for (int i = 0; i< enemy.eShipInFleetList.size();i++){
            Ship currentShip = enemy.eShipInFleetList.get(i);
            currentShip.currentArmor = currentShip.armor;
        }    
    }

    public static int totalFights = 0;
    static int fightsWon = 0;
    static int fightsLost = 0;
    static int fightsDrawn = 0;
    
    static void startFight(Fleet fleet, Enemy enemy){
        totalFights++;
        GUI.totalFightsLabel.setText(convertNumber(totalFights));
        int duration = 0;
        for (int i = 0; i< fleet.shipList.size();i++){
            Ship.setShipValues(fleet.shipList.get(i));
        }
        
        setCurrentArmor(fleet, enemy);
        
        if (fleet.shipList.contains(spyDrone)){
            enemy.spied = true;
            Enemy.enemyReportList.set(enemy.stage-1, "Enemy Stage " + enemy.stage + " (Info)");
            GUI.enemyList.setListData(enemyReportList.toArray());
        }
        
        for (int round = 1; round <= 6; round++){
            reloadShield(fleet, enemy);
            if (enemy.eShipInFleetList.size() > 0){
                
                if (fleet.attackmode.equals("attacking")){
                    fleetAttack(fleet, enemy);
                    enemyAttack(fleet, enemy);
                } else if (fleet.attackmode.equals("defending")){
                    enemyAttack(fleet, enemy); 
                    fleetAttack(fleet, enemy);
                }
            }
            if (fleet.shipList.isEmpty() || enemy.eShipInFleetList.isEmpty()){
                duration = round;
                break;
            }
                
        }
        endFight(fleet, enemy, duration);
    }
    
    static void fleetAttack(Fleet fleet, Enemy enemy){
        for (int i = 0; i< fleet.shipList.size(); i++){
                    Ship currentShip = fleet.shipList.get(i);
                    int currentIndex = fleet.shipNumberList.get(i);
                    for (int j = 0; j< currentIndex; j++){
                        if (enemy.eShipInFleetList.size() > 0){
                            Ship enemyShip = enemy.improvedRandomShip();
                            //System.out.println(enemyShip.currentArmor + " "+ enemyShip.attack +" "+ enemyShip.currentShield);
                            if (rapidFire(currentShip, enemyShip) == true){
                               // System.out.println("Decrease j from " +j + " to" +(j-1));
                                j--;
                            }
                            
                            if (currentShip.attack > 0.01 * enemyShip.currentShield & enemyShip.currentShield > 0){
                                enemyShip.currentShield = enemyShip.currentShield - currentShip.attack;
                            }
                            if (enemyShip.currentShield <= 0) {
                                enemyShip.currentArmor = enemyShip.currentArmor - currentShip.attack;
                                if (enemyShip.currentArmor <= enemyShip.armor * 0.25){ ///////////////////////////////////////////zufällig zerstört bei unter 25%
                                    enemyShip.number--;
                                    enemyShip.lost++;
                                    enemyShip.currentArmor = enemyShip.armor;
                                    enemyShip.currentShield = enemyShip.shield;
                                    if (enemyShip.number == 0){
                                        enemy.eShipInFleetList.remove(enemyShip);
                                    }
                                }
                            }
                        }  
                    }
                }
    }
    
    static void enemyAttack(Fleet fleet, Enemy enemy){
        for (int i = 0; i< enemy.eShipInFleetList.size(); i++){
            Ship enemyShip = enemy.eShipInFleetList.get(i);
            for (int j = 0; j < enemyShip.number; j++){
                if (fleet.shipList.size() > 0){
                    Ship fleetShip = fleet.improvedRandomShip();

                    if (rapidFire(enemyShip, fleetShip) == true){
                       // System.out.println("Decrease j from " +j + " to" +(j-1));
                        j--;
                    }

                    if (enemyShip.attack > 0.01 * fleetShip.currentShield & fleetShip.currentShield > 0){
                        fleetShip.currentShield = fleetShip.currentShield - enemyShip.attack;
                    }
                    if (fleetShip.currentShield <= 0) {
                        fleetShip.currentArmor = fleetShip.currentArmor - enemyShip.attack;
                        if (fleetShip.currentArmor <= fleetShip.armor * 0.25){
                            int fleetShipIndex = fleet.getShipIndex(fleetShip);
                            int fleetShipNumber = fleet.shipNumberList.get(fleetShipIndex);
                            fleetShipNumber--;
                            if (fleet.attackmode.equals("defending")){
                                fleetShip.number--;
                            }
                            fleetShip.lost++;
                            fleetShip.currentArmor = fleetShip.armor;
                            fleetShip.currentShield = fleetShip.shield;
                            if (fleetShipNumber == 0){
                                    fleet.shipList.remove(fleetShipIndex);
                                    fleet.shipNumberList.remove(fleetShipIndex);
                            } else{
                                fleet.shipNumberList.set(fleetShipIndex, fleetShipNumber);
                            }
                        }
                    }
                }
            }
        }
    }
    
    static boolean rapidFire(Ship fleetShip, Ship enemyShip){
        double rfTable [][] ={ 
            {1,1,1,1,1,1,5,1,1},
            {1,1,1,1,1,1,5,1,1},
            {1,1,1,1,1,1,5,1,1},
            {3,1,1,1,1,1,5,1,1},
            {1,1,6,1,1,1,5,1,1},
            {1,1,1,2,1,1,5,1,1},
            {1,1,1,1,1,1,5,1,1},
            {1,1,1,1,2,1,5,1,1},
            {250,250,200,100,33,30,1250,5,0}};
        double rf = rfTable[Ship.getIndex(fleetShip)][Ship.getIndex(enemyShip)];
        double rf_chance = (rf-1)/rf;
        double rndm = Math.random();

        if (rf_chance >= rndm){
           //System.out.println("rf: " +rf +"  rf_chance: "+rf_chance +"  rdnm: "+rndm +" OK");
            return true;
        }
        else {
            //System.out.println("rf: " +rf +"  rf_chance: "+rf_chance +"  rdnm: "+rndm +" Not OK");
            return false;
        }
    }

    static void lostInFight(Enemy enemy){
        double lostPoints = 0;
        double lostEnemyPoints = 0;
        GUI.lostTextArea.setText("");
        for (int i = 0; i < Ship.list.size(); i++){
            Ship currentShip = Ship.list.get(i);
            Ship enemyShip = enemy.eShipList.get(i);
            if (currentShip.lost > 0 | enemyShip.lost > 0){
                
                lostPoints = lostPoints + 
                        (currentShip.metalCost * currentShip.lost + 
                        currentShip.crystalCost * currentShip.lost + 
                        currentShip.deuteriumCost * currentShip.lost)/1000.0;
                
                lostEnemyPoints = lostEnemyPoints + 
                        (enemyShip.metalCost * enemyShip.lost + 
                        enemyShip.crystalCost * enemyShip.lost + 
                        enemyShip.deuteriumCost * enemyShip.lost)/1000.0;
                
                enemy.metal = enemy.metal + (currentShip.metalCost * currentShip.lost + enemyShip.metalCost * enemyShip.lost) * 0.3;
                enemy.crystal = enemy.crystal + (currentShip.crystalCost * currentShip.lost + enemyShip.crystalCost * enemyShip.lost)* 0.3;
                enemy.deuterium = enemy.deuterium + (currentShip.deuteriumCost * currentShip.lost + enemyShip.deuteriumCost * enemyShip.lost)* 0.3;
                
                GUI.historyTextArea.append(currentShip.name +" ( "+ Tools.convertNumber(currentShip.lost) + " / "+ Tools.convertNumber(enemyShip.lost) +" )" + "\n");
                
                currentShip.lostTotal = currentShip.lostTotal + currentShip.lost;
                Ship.totalLostShips = Ship.totalLostShips + currentShip.lost;
                currentShip.lost = 0;
                
                enemyShip.lostTotal = enemyShip.lostTotal + enemyShip.lost;
                Enemy.totalLostShips = Enemy.totalLostShips + enemyShip.lost;
                enemyShip.lost = 0;
                currentShip.textArea.setText(currentShip.toString());
            }
            Enemy.lostShips.set(i, enemyShip.lostTotal + Enemy.lostShips.get(i));
            GUI.totalLostShipLabel.setText(Tools.convertNumber(Ship.totalLostShips) + " / " + Tools.convertNumber(Enemy.totalLostShips));
            GUI.lostTextArea.append(currentShip.name + ": " +Tools.convertNumber(currentShip.lostTotal) + " / " + Tools.convertNumber(Enemy.lostShips.get(i))+ "\n");  
        }
        GUI.historyTextArea.append("Points lost" + " ( "+ Tools.convertNumber(lostPoints) + " / "+ Tools.convertNumber(lostEnemyPoints) +" )" + "\n");
    }
    
    static void wreckingLoot(Ship currentShip, Ship enemyShip, Enemy enemy){
        enemy.metal = enemy.metal + (currentShip.metalCost * currentShip.lost + enemyShip.metalCost * enemyShip.lost) * 0.3;
        enemy.crystal = enemy.crystal + (currentShip.crystalCost * currentShip.lost + enemyShip.crystalCost * enemyShip.lost)* 0.3;
        enemy.deuterium = enemy.deuterium + (currentShip.deuteriumCost * currentShip.lost + enemyShip.deuteriumCost * enemyShip.lost)* 0.3;
    }
    
    static void endFight(Fleet fleet, Enemy enemy, int duration){
       
        Calendar cal = Calendar.getInstance ();
        if (fleet.attackmode.equals("attacking")){
            GUI.historyTextArea.append("\n" +"Fleet ID " + String.valueOf(fleet.ID) + " fought at " 
                + cal.get( Calendar.DAY_OF_MONTH ) +"."
                + (cal.get( Calendar.MONTH ) + 1 ) +"."
                + cal.get( Calendar.YEAR ) +" -- "
                + cal.get( Calendar.HOUR_OF_DAY ) + ":"
                + cal.get( Calendar.MINUTE ) + ":"
                + cal.get( Calendar.SECOND ) + " with Enemy Stage " + enemy.stage + "\n");
        } 
            
        if (fleet.shipList.size() > 0 & enemy.eShipInFleetList.isEmpty()){
            GUI.historyTextArea.append("Battle won after " +String.valueOf(duration)+ " rounds! \n");
            fightsWon++;
            GUI.fightsWonLabel.setText(convertNumber(fightsWon));
            lostInFight(enemy);
            fleet.loadLoot();
            GUI.historyTextArea.append("Looted Ressources:"  + "\n" 
                                        + "Metal: " + Tools.convertNumber(fleet.loadedMetal) + "\n" 
                                        + "Crystal: " + Tools.convertNumber(fleet.loadedCrystal) + "\n" 
                                        + "Deuterium: " + Tools.convertNumber(fleet.loadedDeuterium) + "\n");
            fleet.returning = true;
            fleet.publish();
            if (fleet.resumed==false)
                Countdown.flightTimer(fleet);
            
            enemy.defeated = true;
            Enemy.renewEnemy(enemy.stage);
            if (Enemy.getLastEnemy().defeated == true)
                Enemy.newEnemy(new Enemy());
            
        }
        else if (fleet.shipList.size() > 0 & enemy.eShipInFleetList.size() > 0 ){
            GUI.historyTextArea.append("Nothing looted." + "\n");
            fightsDrawn++;
            GUI.fightsDrawnLabel.setText(convertNumber(fightsDrawn));
            lostInFight(enemy);
            fleet.returning = true;
            fleet.publish();
            if (fleet.resumed == false)
                Countdown.flightTimer(fleet);
        }
        
        else if (fleet.shipList.isEmpty()){
            GUI.historyTextArea.append("Complete fleet lost after " +String.valueOf(duration)+ " rounds. \n");
            fightsLost++;
            GUI.fightsLostLabel.setText(convertNumber(fightsLost));
            lostInFight(enemy);
            if (fleet.attackmode.equals("attacking"))
                fleet.removeFleetFromList();
            enemy.targeted = false;
            Output.fleetReport();
        }
        setPoints();
    }
    
    static void dockingProcedure(Fleet fleet){
        fleet.target.targeted = false;
        fleet.dockingFleet();
        fleet.unloadLoot();
        Output.fleetReport();
    }
   
   
    
 
}
