
package ShipPackage;

import BuildingPackage.*;
import GamePackage.*;
import ResearchPackage.*;
import static ResearchPackage.Research.*;

import java.util.ArrayList;
import java.util.List;

public class Ship extends GameObject{

    //Ships
    public static List<Ship> list = new ArrayList<>();
    public static List<GameObject> shipyardList = new ArrayList<>();
    public static List<Integer> numberList = new ArrayList<>();
    public static List<String> shipyardBuildList = new ArrayList<>();
    
    public static BattleShip battleShip = new BattleShip();    
    public static Dreadnought dreadnought = new Dreadnought();    
    public static Cruiser cruiser = new Cruiser();    
    public static Destroyer destroyer = new Destroyer();    
    public static HeavyFighter heavyFighter = new HeavyFighter();
    public static LargeTransporter largeTransporter = new LargeTransporter();
    public static LightFighter lightFighter = new LightFighter();    
    public static SmallTransporter smallTransporter = new SmallTransporter();    
    public static SpyDrone spyDrone = new SpyDrone(); 
    
    public static long totalLostShips = 0;
        
    public static void add(){
        list.add(smallTransporter);    
        list.add(largeTransporter);
        list.add(lightFighter);
        list.add(heavyFighter);
        list.add(cruiser);
        list.add(battleShip);
        list.add(spyDrone);    
        list.add(destroyer);
        list.add(dreadnought);
        }  
    
    public static int getIndex(Ship ship){
        int index = 0;
        for (int i = 0; i < list.size(); i++){
            if (ship.name.equals(list.get(i).name)){
                index = i; 
            }
        }
        return index;
    }
    
    public static void setShipValues(GameObject obj){
        if (obj.equals(combustionTech) | obj.equals(impulseTech) | obj.equals(hyperspaceDrive) | Ship.class.isInstance(obj))
            setVelocity();
        if (obj.equals(armorTech) | Ship.class.isInstance(obj))
            setArmor();
        if (obj.equals(weaponTech) | Ship.class.isInstance(obj))
            setAttack();
        if (obj.equals(shieldTech) | Ship.class.isInstance(obj))
            setShield();
    }
    
    static void setVelocity(){
            Ship currentShip;
            for(int i=0; i < list.size(); i++){
                currentShip = list.get(i);
                if (currentShip.equals(lightFighter) | currentShip.equals(smallTransporter) | currentShip.equals(spyDrone) | currentShip.equals(largeTransporter)){
                    currentShip.velocity =  (int) Math.round(currentShip.groundVelocity * (1+ (0.1 * Research.combustionTech.stage)) * Math.pow(1.5, Building.massPortal.stage));
                }
                if (currentShip.equals(heavyFighter)  | currentShip.equals(cruiser)){
                    currentShip.velocity =  (int) Math.round(currentShip.groundVelocity * (1+ (0.2 * Research.impulseTech.stage))* Math.pow(1.5, Building.massPortal.stage));
                }
                if (currentShip.equals(battleShip) | currentShip.equals(destroyer) | currentShip.equals(dreadnought)){
                    currentShip.velocity =  (int) Math.round(currentShip.groundVelocity * (1+ (0.3 * Research.hyperspaceDrive.stage))* Math.pow(1.5, Building.massPortal.stage));
                }
            }
    }

    static void setAttack(){
        Ship currentShip;
        for(int i=0; i < list.size(); i++){
            currentShip = list.get(i);
            currentShip.attack =  (int) ((currentShip.groundAttack * (1+ weaponTech.stage/10.0)));
        }
    }
    
    static void setArmor(){
        for(int i=0; i < list.size(); i++){
            Ship currentShip = list.get(i);
            currentShip.armor =  (int) ((currentShip.metalCost + currentShip.crystalCost)/10.0 * (1+ armorTech.stage/10.0));
        }
    }
    
    static void setShield(){
        for(int i=0; i < list.size(); i++){
            Ship currentShip = list.get(i);
            currentShip.shield =  (int) (currentShip.groundShield * (1+ shieldTech.stage/10.0));
        }
    }
    
    public static int getNumber(){
        int shipNumber=0;
        for(int i=0; i < list.size(); i++){
            shipNumber = shipNumber + list.get(i).number; 
        }
        return shipNumber;
    }
    
    public static void getNextShip(){
        if (shipyardList.size() > 0){
            shipyardList.get(0).numberToBuild = numberList.get(0);
            Tools.startProduction(shipyardList.get(0));
        }
    } 
    
    public static void addToShipyardList(GameObject obj){
        int numberToBuild = Integer.parseInt(obj.textField.getText());
        if (numberToBuild > 0){
            shipyardList.add(obj);
            numberList.add(numberToBuild);
            shipyardBuildList.clear();
            for(int i = 0 ; i < shipyardList.size() ; i++){
               shipyardBuildList.add(shipyardList.get(i).name + "  (" + numberList.get(i) + ")");
            }
            if (shipyardList.size()==1){
                getNextShip();
            }
            Tools.payProduction(obj);
            Output.shipyardReport();
        }
    }
    
    public static int getShipyardProductionTime(){
        int shipyardProductionTime_index_0 = 0;
        int shipyardProductionTime = 0;
        if (shipyardList.size() > 0){
            shipyardProductionTime_index_0 = shipyardList.get(0).currentTime + shipyardList.get(0).time * (numberList.get(0)-1);
            for (int i = 1; i < shipyardList.size(); i++){
            shipyardProductionTime = shipyardProductionTime + shipyardList.get(i).time * numberList.get(i);
            }
        shipyardProductionTime = shipyardProductionTime + shipyardProductionTime_index_0;  
        }
        return shipyardProductionTime;
    }
    
    public static void increaseShipNumber(GameObject obj, int amount){
        obj.number = obj.number + amount;
        Output.report(obj);
    }
    
        
    public Ship (){
        super();
    }
    
    
       @Override 
    public String toString()
    {
        return ( 
                name + " ("+ Tools.convertNumber(number) + ")"
                + "\n Armor: " + Tools.convertNumber(armor)
                + "\n Attack / Shield: " + Tools.convertNumber(attack)+ " / " + Tools.convertNumber(shield)
                + "\n Velocity: " + Tools.convertNumber(velocity)
                + "\n Capacity: " + Tools.convertNumber(cargoCapacity ) 

                + "\n Metal cost: " + Tools.convertNumber(metalCost)
                + "\n Crystal cost: " + Tools.convertNumber(crystalCost)
                + "\n Deuterium cost: " + Tools.convertNumber(deuteriumCost)
                + "\n" 
                + "\n Time: " + Tools.convertTime(time) 
                
        );
    }
    
    
    
}
